--- ./clientbot/fpcount/server/fpcount.cpp.allpat	Mon Feb 10 10:52:04 2003
+++ ./clientbot/fpcount/server/fpcount.cpp	Tue Jan 28 09:10:26 2003
@@ -270,7 +270,11 @@
     }
     else
     {
-        file = new ifstream(fullCustomFileName, ios::in | IOS_BINARY | ios::nocreate);        
+#ifndef DUNIX
+      file = new ifstream(fullCustomFileName, ios::in | IOS_BINARY | ios::nocreate);        
+#else
+      file = new ifstream(fullCustomFileName, ios::in | ios::nocreate);
+#endif
     }
 
     if (file == NULL)
--- ./clientbot/fpcount/server/gd.cpp.allpat	Mon Feb 10 10:52:16 2003
+++ ./clientbot/fpcount/server/gd.cpp	Tue Jan 28 11:12:20 2003
@@ -1517,7 +1517,7 @@
 // and take a istream parameter rather than reading from a fd
 inline int ReadOK(istream &file, unsigned char buffer[], int len)
 {    
-    file.read(buffer, len);
+    file.read((char *)buffer, len);
     return file.ipfx(1);
     // return (file->Read(buffer, len) != 0);
 }
--- ./clientbot/fpcount/server/makefile.allpat	Mon Feb 10 10:52:23 2003
+++ ./clientbot/fpcount/server/makefile	Wed Mar 26 14:06:07 2003
@@ -43,7 +43,16 @@
 # If you are compiling for use on a non-SGI Unix platform, uncomment 
 # the following lines
 #
-CC = gcc
+#CC = gcc
+#this definition points to the library with the malloc(0) fix.
+ifeq "$(PLATFORM)" "alpha"
+CC = /pub/dinkumware/$(PLATFORM)-malloc/Compilex 
+COMPLD = /pub/dinkumware/$(PLATFORM)-malloc/Linkx
+else
+CC = /pub/dinkumware/$(PLATFORM)/Compilex 
+COMPLD = /pub/dinkumware/$(PLATFORM)/Linkx
+endif
+
 ifeq "$(PLATFORM)" "bsdi"
 CFLAGS = -c -Wall -DUNIX -DNDEBUG -DBSDI $(COPT)
 else
@@ -53,22 +62,33 @@
 ifeq "$(PLATFORM)" "sco5"
 CFLAGS = -c -Wall -DUNIX -DNDEBUG -DSCO5 $(COPT)
 else
-CFLAGS = -c -Wall -DUNIX -DNDEBUG -fPIC $(COPT)
+ifeq "$(PLATFORM)" "sgi"
+CFLAGS = -I/pub/dinkumware/sgi/include
+CFLAGS += -c -Wall -DUNIX -DNDEBUG -DDUNIX -DSGI -fhonor-std -Wno-missing-braces -fPIC $(COPT)
+else
+ifeq "$(PLATFORM)" "solarisx86"
+CFLAGS = -I/pub/dinkumware/solarisx86/include
+CFLAGS += -c -Wall -DUNIX -DNDEBUG -DDUNIX -DSOLARISX86 -fhonor-std -Wno-missing-braces -fPIC $(COPT)
+else
+CFLAGS = -c -Wall -DUNIX -DNDEBUG -DDUNIX -Wno-missing-braces -fPIC $(COPT)
+endif
+endif
 endif
 endif
 endif
+CFLAGS += -DDUNIX
 COUT = -o $@
 LD_DLL_FLAGS = -nostdlib -shared
 LDBINOUT = -o $@
 CHMOD =
 ifeq "$(PLATFORM)" "linux"
-EXE_LINK_FLAGS = -Xlinker -static -lstdc++ -lm
+EXE_LINK_FLAGS = -lm
 else
 ifeq "$(PLATFORM)" "mips-linux"
-EXE_LINK_FLAGS = -Xlinker -static -lstdc++ -lm
-CC=g++
+EXE_LINK_FLAGS =  -lm
+CC=/pub/dinkumware/$(PLATFORM)/Compilex
 else
-EXE_LINK_FLAGS = -lstdc++ -lm
+EXE_LINK_FLAGS = -lm
 endif
 endif
 #
@@ -125,7 +145,7 @@
 	$(CHMOD)
 
 $(BIN)/fpcount.exe: $(FPCOUNT_OBJS)
-	$(CC) $(FPCOUNT_OBJS) $(LDBINOUT) $(EXE_LINK_FLAGS)
+	$(COMPLD) $(FPCOUNT_OBJS) $(LDBINOUT) $(EXE_LINK_FLAGS)
 
 $(BIN)/fpcount.res: fpcount.rc
 	rc -I../../.. -fo$(BIN)/fpcount.res fpcount.rc
--- ./config/linux.h.allpat	Mon Feb 10 09:58:35 2003
+++ ./config/linux.h	Thu Dec  5 13:46:54 2002
@@ -20,7 +20,8 @@
 #define V_ENDIAN    V_BIG_ENDIAN
 #else
 #define I386                            /* Intel X86 Hardware */
-#define V_ENDIAN    V_LITTLE_ENDIAN
+//#define V_ENDIAN    V_LITTLE_ENDIAN
+#define V_ENDIAN    V_BIG_ENDIAN
 #endif
 
 #ifdef __svr4__
--- ./config/freebsd.mak.allpat	Tue Feb 18 12:58:05 2003
+++ ./config/freebsd.mak	Wed Feb 19 07:56:59 2003
@@ -22,8 +22,12 @@
 # If this env var is set to something else some makes will use that instead
 SHELL = /bin/sh
 
-CC		= gcc
-CXX		= g++
+#CC		= gcc
+#CXX		= g++
+CC = /pub/dinkumware/freebsd/Compilex -DDUNIX
+CXX = /pub/dinkumware/freebsd/Compilex -DDUNIX
+COMPLD = /pub/dinkumware/freebsd/Linkx
+COMPMULT = /pub/dinkumware/freebsd/Linkx
 
 SYSLIBS		= -lcrypt -lm 
 TCLLIBS		= -L/usr/X11/lib -lX11 -lipc  # FIX: Use correct location
@@ -69,7 +73,8 @@
 # not worth the hassle of kicking through all those warnings.
 #
 CF_WARN_CC=-Wtrigraphs -Wswitch -Wimplicit -Wformat -Wcomment -Wchar-subscripts  -Wwrite-strings  # warnings we want to see in C
-CF_WARN=-Wtemplate-debugging -Wreorder -Wreturn-type -Wsynth $(CF_WARN_CC)
+#CF_WARN=-Wtemplate-debugging -Wreorder -Wreturn-type -Wsynth $(CF_WARN_CC)
+CF_WARN=-Wreorder -Wreturn-type -Wsynth $(CF_WARN_CC)
 CF_BINOUT=-o $@		# specify where object module goes
 ifndef DEBUG
 CF_WARN += -Wuninitialized
@@ -160,18 +165,18 @@
 	@echo '#include "util/version.h"'                   >> version.cpp
 	@$(CXX) $(CXXFLAGS) $(CF_WARN) -c version.cpp -o $(BINDIR)/version$O
 	@echo done
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O $(filter %$A,$^) \
 					$(SYSLIBS)
 endef
 
 define MAKETCLEXE
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(TCLLIBS) $(SYSLIBS)
 endef
 
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(SYSLIBS)
 endef
 
--- ./config/freebsd.h.allpat	Mon Feb 10 10:54:02 2003
+++ ./config/freebsd.h	Wed Feb 19 07:55:24 2003
@@ -1,8 +1,7 @@
-
 /*
  * Copyright (c) 1995 Vermeer Technologies, Inc.
  *
- * config/freebsd.h
+ * config/bsdi.h
  *
  * BSDI-specific configuration
  * 
@@ -32,3 +31,4 @@
 #define S_IAMB 0x1FF
 
 #endif /* CONFIG_BSDI_H */
+
--- ./config/freebsd.hpp.allpat	Mon Feb 10 10:04:38 2003
+++ ./config/freebsd.hpp	Tue Dec  3 15:33:46 2002
@@ -1,6 +1,22 @@
 /*
  * Copyright (c) 1995 Vermeer Technologies, Inc.
  *
+ * config/bsdi.hpp
+ *
+ * BSDI C++ configuration
+ *
+ *
+ */
+
+#ifndef CONFIG_BSDI_HXX
+#define CONFIG_BSDI_HXX
+
+// initial version
+
+#endif /* CONFIG_BSDI_HXX */
+/*
+ * Copyright (c) 1995 Vermeer Technologies, Inc.
+ *
  * config/freebsd.hpp
  *
  * BSDI C++ configuration
--- ./config/alpha.mak.allpat	Mon Feb 10 10:53:39 2003
+++ ./config/alpha.mak	Mon Mar 24 09:08:18 2003
@@ -12,8 +12,12 @@
 # If this env var is set to something else some makes will use that instead
 SHELL = /bin/sh
 
-CC		= gcc
-CXX		= g++
+#CC		= gcc
+#CXX		= g++
+CC = /pub/dinkumware/alpha-malloc/Compilex -DDUNIX 
+CXX = /pub/dinkumware/alpha-malloc/Compilex -DDUNIX
+COMPLD = /pub/dinkumware/alpha-malloc/Linkx 
+COMPMULT = /pub/dinkumware/alpha-malloc/Linkx
 
 SYSLIBS		= -lm 
 TCLLIBS		= -L/usr/lib -lX11 
@@ -177,14 +181,14 @@
 ifndef SHARED_LIBRARIES
 define MAKEVERSIONEXE
 	$(MAKEVERSION)
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O $(filter %$A,$^) \
 					$(SYSLIBS)
 endef
 else
 define MAKEVERSIONEXE
 	$(MAKEVERSION)
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O \
             $(foreach lib,$(filter %$(AE),$^),-L$(dir $(lib)) \
                 -l$(subst lib,,$(subst $(AE),,$(notdir $(lib))))) \
@@ -208,12 +212,12 @@
 
 ifndef SHARED_LIBRARIES
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(SYSLIBS)
 endef
 else
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
             $(foreach lib,$(filter %$(AE),$^),-L$(dir $(lib)) \
                 -l$(subst lib,,$(subst $(AE),,$(notdir $(lib))))) \
                                         $(SYSLIBS) $(LF_SHARED)
--- ./config/bsdi.mak.allpat	Mon Feb 10 10:53:49 2003
+++ ./config/bsdi.mak	Fri Jan 24 15:51:56 2003
@@ -22,8 +22,12 @@
 # If this env var is set to something else some makes will use that instead
 SHELL = /bin/sh
 
-CC		= gcc
-CXX		= g++
+#CC		= gcc
+#CXX		= g++
+CC = /pub/dinkumware/bsdi/Compilex -DDUNIX
+CXX = /pub/dinkumware/bsdi/Compilex -DDUNIX
+COMPLD = /pub/dinkumware/bsdi/Linkx
+COMPMULT = /pub/dinkumware/bsdi/Linkx
 
 SYSLIBS		= -ldl -lm 
 TCLLIBS		= -L/usr/X11/lib -lX11 -lipc  # FIX: Use correct location
@@ -69,7 +73,8 @@
 # not worth the hassle of kicking through all those warnings.
 #
 CF_WARN_CC=-Wtrigraphs -Wswitch -Wimplicit -Wformat -Wcomment -Wchar-subscripts  -Wwrite-strings  # warnings we want to see in C
-CF_WARN=-Wtemplate-debugging -Wreorder -Wreturn-type -Wsynth $(CF_WARN_CC)
+#CF_WARN=-Wtemplate-debugging -Wreorder -Wreturn-type -Wsynth $(CF_WARN_CC)
+CF_WARN=-Wreorder -Wreturn-type -Wsynth $(CF_WARN_CC)
 CF_BINOUT=-o $@		# specify where object module goes
 ifndef DEBUG
 CF_WARN += -Wuninitialized
@@ -160,18 +165,18 @@
 	@echo '#include "util/version.h"'                   >> version.cpp
 	@$(CXX) $(CXXFLAGS) $(CF_WARN) -c version.cpp -o $(BINDIR)/version$O
 	@echo done
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O $(filter %$A,$^) \
 					$(SYSLIBS)
 endef
 
 define MAKETCLEXE
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(TCLLIBS) $(SYSLIBS)
 endef
 
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(SYSLIBS)
 endef
 
--- ./config/hp700.mak.allpat	Mon Feb 10 10:54:33 2003
+++ ./config/hp700.mak	Fri Jan 24 15:55:07 2003
@@ -22,8 +22,12 @@
 # If this env var is set to something else some makes will use that instead
 SHELL = /bin/sh
 
-CC		= gcc
-CXX		= g++
+#CC		= gcc
+#CXX		= g++
+CC = /pub/dinkumware/hp700/Compilex -DDUNIX
+CXX = /pub/dinkumware/hp700/Compilex -DDUNIX
+COMPLD = /pub/dinkumware/hp700/Linkx
+COMPMULT = /pub/dinkumware/hp700/Linkx
 
 SYSLIBS		= -lm  /usr/lib/libdld.sl
 TCLLIBS		= /usr/lib/X11R5/libX11.sl
@@ -90,7 +94,7 @@
 	@echo '#include "util/base.hpp"'                    > version.cpp
 	@echo '#define V_VERSION_FUNC V$(SUFFIX)Version'    >> version.cpp
 	@echo '#define V_VERSION_LIBNAME "lib$(SUFFIX)"'    >> version.cpp
-	@echo '#define V_VERSION_PLATFORM "SunOS 4.1"'      >> version.cpp
+	@echo '#define V_VERSION_PLATFORM "HP-UX"'      >> version.cpp
 	@echo '#define V_VERSION_BY "'`whoami`'"'           >> version.cpp
 	@echo '#define V_VERSION_HOST "'`hostname`'"'       >> version.cpp
 	@echo '#define V_VERSION_DATE "'`date`'"'           >> version.cpp
@@ -146,7 +150,7 @@
 	@echo '#include "util/version.h"'                   >> version.cpp
 	@$(CXX) $(CXXFLAGS) $(CF_WARN) -c version.cpp -o $(BINDIR)/version$O
 	@echo done
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O $(filter %$A,$^) \
 					$(SYSLIBS)
 endef
@@ -157,7 +161,7 @@
 endef
 
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(SYSLIBS)
 endef
 
--- ./config/linux.mak.allpat	Mon Feb 10 10:54:46 2003
+++ ./config/linux.mak	Wed Mar 19 09:37:56 2003
@@ -12,8 +12,12 @@
 # If this env var is set to something else some makes will use that instead
 SHELL = /bin/sh
 
-CC		= gcc
-CXX		= g++
+#CC		= gcc
+#CXX		= g++
+CC = /pub/dinkumware/linux/Compilex -DDUNIX 
+CXX = /pub/dinkumware/linux/Compilex -DDUNIX
+COMPLD = /pub/dinkumware/linux/Linkx 
+COMPMULT = /pub/dinkumware/linux/Linkx
 
 SYSLIBS		= -lcrypt -ldl -lm
 TCLLIBS		= -L/usr/X11R6/lib -lX11 
@@ -85,7 +89,8 @@
 #
 CF_SYSINC=		# system include file path(s), separated by spaces
 CF_OTHER=-DLINUX -funsigned-char # for other platform-specific compiler flags
-CF_WARN_CC=-Wall -Wno-parentheses -Wno-implicit-int -Wsynth -Wcast-qual -Wwrite-strings  # warnings we want to see
+#CF_WARN_CC=-Wall -Wno-parentheses -Wno-implicit-int -Wsynth -Wcast-qual -Wwrite-strings  # warnings we want to see
+CF_WARN_CC=-Wall -Wno-parentheses -Wno-implicit-int -Wsynth -Wwrite-strings  # warnings we want to see
 CF_WARN= $(CF_WARN_CC)
 CF_BINOUT=-o $@		# specify where object module goes
 
@@ -122,7 +127,7 @@
 	@echo '#define V_VERSION_HOST "'`hostname`'"'       >> version.cpp
 	@echo '#define V_VERSION_DATE "'`date`'"'           >> version.cpp
 	@echo '#include "util/version.h"'                   >> version.cpp
-	@$(CXX) $(CXXFLAGS) $(CF_WARN) -c version.cpp -o $(BINDIR)/version$O
+	$(CXX) $(CXXFLAGS) $(CF_WARN) -c version.cpp -o $(BINDIR)/version$O
 	@echo done
 	-rm -f $@
 	$(AR) $@ $(AF_SHARED) $^ $(BINDIR)/version$O
@@ -171,20 +176,20 @@
 	@echo '#define V_VERSION_HOST "'`hostname`'"'       >> version.cpp
 	@echo '#define V_VERSION_DATE "'`date`'"'           >> version.cpp
 	@echo '#include "util/version.h"'                   >> version.cpp
-	@$(CXX) $(CXXFLAGS) $(CF_WARN) -c version.cpp -o $(BINDIR)/version$O
+	$(CXX) $(CXXFLAGS) $(CF_WARN) -c version.cpp -o $(BINDIR)/version$O
 	@echo done
 endef
 ifndef SHARED_LIBRARIES
 define MAKEVERSIONEXE
 	$(MAKEVERSION)
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O $(filter %$A,$^) \
 					$(SYSLIBS)
 endef
 else
 define MAKEVERSIONEXE
 	$(MAKEVERSION)
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O \
             $(foreach lib,$(filter %$(AE),$^),-L$(dir $(lib)) \
                 -l$(subst lib,,$(subst $(AE),,$(notdir $(lib))))) \
@@ -208,12 +213,12 @@
 
 ifndef SHARED_LIBRARIES
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(SYSLIBS)
 endef
 else
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
             $(foreach lib,$(filter %$(AE),$^),-L$(dir $(lib)) \
                 -l$(subst lib,,$(subst $(AE),,$(notdir $(lib))))) \
                                         $(SYSLIBS) $(LF_SHARED)
--- ./config/sgi.mak.allpat	Mon Feb 10 10:54:55 2003
+++ ./config/sgi.mak	Wed Feb 19 12:38:38 2003
@@ -22,8 +22,12 @@
 # If this env var is set to something else some makes will use that instead
 SHELL = /bin/sh
 
-CC		= gcc
-CXX		= g++
+#CC		= gcc
+#CXX		= g++
+CC = /pub/dinkumware/sgi/Compilex -DDUNIX -fhonor-std -I/pub/dinkumware/sgi/include
+CXX = /pub/dinkumware/sgi/Compilex -DDUNIX -fhonor-std -I/pub/dinkumware/sgi/include
+COMPLD = /pub/dinkumware/sgi/Linkx -fhonor-std -I/pub/dinkumware/sgi/include
+COMPMULT = /pub/dinkumware/sgi/Linkx -fhonor-std -I/pub/dinkumware/sgi/include
 
 SYSLIBS		= -lm 
 TCLLIBS		= -L/usr/local/lib -lX11  # FIX: Use correct location
@@ -58,7 +62,8 @@
 # C/C++ Compiler flags
 CF_SYSINC=		# system include file path(s), separated by spaces
 CF_OTHER=-DSGI -funsigned-char # for other platform-specific compiler flags
-CF_WARN_CC=-Wall -Wno-parentheses -Wsynth -Wcast-qual -Wwrite-strings  # warnings we want to see
+#CF_WARN_CC=-Wall -Wno-parentheses -Wsynth -Wcast-qual -Wwrite-strings  # warnings we want to see
+CF_WARN_CC=-Wall -Wno-parentheses -Wsynth -Wwrite-strings  # warnings we want to see
 CF_WARN= $(CF_WARN_CC)
 CF_BINOUT=-o $@		# specify where object module goes
 
@@ -114,7 +119,6 @@
 	    (cd $$dir; $(MAKE) $(MFLAGS) $@); \
 	done
 endef
-
 # MAKEEXE - link stuff
 # Inputs: the list of dependencies should include all the object.
 #		Libraries needed for linking should be in the LIBS variable.
@@ -126,13 +130,6 @@
 #	together so that each -Lpath... comes immediately before the
 #	corresponding -larchive.
 #
-ifndef DEBUG
-STRIP=-Xlinker -s
-STRIPEXE=-Xlinker -s
-endif
-ifndef DEBUG_TESTS
-STRIPEXE=-Xlinker -s
-endif
 
 define MAKEVERSIONEXE
 	@echo Making a new timestamp...
@@ -146,7 +143,7 @@
 	@echo '#include "util/version.h"'                   >> version.cpp
 	@$(CXX) $(CXXFLAGS) $(CF_WARN) -c version.cpp -o $(BINDIR)/version$O
 	@echo done
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O $(filter %$A,$^) \
 					$(SYSLIBS)
 endef
@@ -157,7 +154,7 @@
 endef
 
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(SYSLIBS)
 endef
 
--- ./config/solaris.mak.allpat	Mon Feb 10 10:55:13 2003
+++ ./config/solaris.mak	Fri Feb 21 14:25:34 2003
@@ -12,8 +12,12 @@
 # If this env var is set to something else some makes will use that instead
 SHELL = /bin/sh
 
-CC		= gcc
-CXX		= g++
+#CC		= gcc
+#CXX		= g++
+CC = /pub/dinkumware/solaris/Compilex -DDUNIX
+CXX = /pub/dinkumware/solaris/Compilex -DDUNIX
+COMPLD = /pub/dinkumware/solaris/Linkx
+COMPMULT = /pub/dinkumware/solaris/Linkx
 
 SYSLIBS		= -lnsl -lm -ldl -lsocket
 TCLLIBS		= -L/usr/openwin/lib -lX11
@@ -85,9 +89,11 @@
 #
 CF_SYSINC=		# system include file path(s), separated by spaces
 CF_OTHER=-DSOLARIS -funsigned-char # for other platform-specific compiler flags
-CF_WARN_CC=-Wall -Wno-parentheses -Wsynth -Wcast-qual -Wwrite-strings -Wno-sign-compare  # warnings we want to see
+#CF_WARN_CC=-Wall -Wno-parentheses -Wsynth -Wcast-qual -Wwrite-strings -Wno-sign-compare  # warnings we want to see
+CF_WARN_CC=-Wall -Wno-parentheses -Wsynth  -Wwrite-strings -Wno-sign-compare  -Wno-missing-braces # warnings we want to see
 CF_WARN= $(CF_WARN_CC)
 CF_BINOUT=-o $@		# specify where object module goes
+CXXFLAG+= -Wno-missing-braces
 
 # REVIEW: CF_WARN probably wants to have -Winline, and CF_OPT wants to have
 #         -Fno-implement-inlines.  However, there are 5-6 inlines in Rogue
@@ -177,14 +183,14 @@
 ifndef SHARED_LIBRARIES
 define MAKEVERSIONEXE
 	$(MAKEVERSION)
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O $(filter %$A,$^) \
 					$(SYSLIBS)
 endef
 else
 define MAKEVERSIONEXE
 	$(MAKEVERSION)
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O \
             $(foreach lib,$(filter %$(AE),$^),-L$(dir $(lib)) \
                 -l$(subst lib,,$(subst $(AE),,$(notdir $(lib))))) \
@@ -208,12 +214,12 @@
 
 ifndef SHARED_LIBRARIES
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(SYSLIBS)
 endef
 else
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
             $(foreach lib,$(filter %$(AE),$^),-L$(dir $(lib)) \
                 -l$(subst lib,,$(subst $(AE),,$(notdir $(lib))))) \
                                         $(SYSLIBS) $(LF_SHARED)
--- ./config/solarisx86.mak.allpat	Mon Feb 10 10:55:22 2003
+++ ./config/solarisx86.mak	Thu Feb 20 09:23:49 2003
@@ -12,8 +12,12 @@
 # If this env var is set to something else some makes will use that instead
 SHELL = /bin/sh
 
-CC		= gcc
-CXX		= g++
+#CC		= gcc
+#CXX		= g++
+CC = /pub/dinkumware/solarisx86/Compilex -fhonor-std -DDUNIX -I/pub/dinkumware/solarisx86/include
+CXX = /pub/dinkumware/solarisx86/Compilex -fhonor-std -DDUNIX -I/pub/dinkumware/solarisx86/include
+COMPLD = /pub/dinkumware/solarisx86/Linkx -fhonor-std -DDUNIX -I/pub/dinkumware/solarisx86/include
+COMPMULT = /pub/dinkumware/solarisx86/Linkx -fhonor-std -DDUNIX -I/pub/dinkumware/solarisx86/include
 
 SYSLIBS		= -lnsl -lm -ldl -lsocket
 TCLLIBS		= -L/usr/openwin/lib -lX11
@@ -85,7 +89,8 @@
 #
 CF_SYSINC=		# system include file path(s), separated by spaces
 CF_OTHER=-DSOLARISX86 -funsigned-char # for other platform-specific compiler flags
-CF_WARN_CC=-Wall -Wno-parentheses -Wsynth -Wcast-qual -Wwrite-strings -Wno-sign-compare  # warnings we want to see
+#CF_WARN_CC=-Wall -Wno-parentheses -Wsynth -Wcast-qual -Wwrite-strings -Wno-sign-compare  # warnings we want to see
+CF_WARN_CC=-Wall -Wno-parentheses -Wsynth -Wwrite-strings -Wno-sign-compare -Wno-missing-braces # warnings we want to see
 CF_WARN= $(CF_WARN_CC)
 CF_BINOUT=-o $@		# specify where object module goes
 
@@ -177,14 +182,14 @@
 ifndef SHARED_LIBRARIES
 define MAKEVERSIONEXE
 	$(MAKEVERSION)
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O $(filter %$A,$^) \
 					$(SYSLIBS)
 endef
 else
 define MAKEVERSIONEXE
 	$(MAKEVERSION)
-	$(PURIFY) $(CXX) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIP) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(BINDIR)/version$O \
             $(foreach lib,$(filter %$(AE),$^),-L$(dir $(lib)) \
                 -l$(subst lib,,$(subst $(AE),,$(notdir $(lib))))) \
@@ -208,12 +213,12 @@
 
 ifndef SHARED_LIBRARIES
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
                                         $(filter %$A,$^) $(SYSLIBS)
 endef
 else
 define MAKEEXE
-	$(PURIFY) $(CXX) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
+	$(PURIFY) $(COMPMULT) $(STRIPEXE) $(LD_PROF) -o $@ $(filter %$O,$^) \
             $(foreach lib,$(filter %$(AE),$^),-L$(dir $(lib)) \
                 -l$(subst lib,,$(subst $(AE),,$(notdir $(lib))))) \
                                         $(SYSLIBS) $(LF_SHARED)
--- ./htmlpars/OrigText.cpp.allpat	Mon Feb 10 10:41:05 2003
+++ ./htmlpars/OrigText.cpp	Tue Dec  3 15:33:46 2002
@@ -766,7 +766,7 @@
 			*pwc = *pc++;
         else
         {
-            *pwc = Vutf8CharToUnicodeChar(pc, bWellFormed);
+            *pwc = Vutf8CharToUnicodeChar((const Vchar*)pc, bWellFormed);
             if (!*pwc)
                 pwc--;
         }
--- ./htmlpars/OrigText.h.allpat	Mon Feb 10 10:41:19 2003
+++ ./htmlpars/OrigText.h	Tue Dec  3 15:33:46 2002
@@ -188,11 +188,11 @@
 	Vbool operator <(const VFileTextSubstring& fts) const;
 	Vbool operator >(const VFileTextSubstring& fts) const;
 	Vbool operator ==(const VFileTextSubstring& fts) const;
-	inline operator <=(const VFileTextSubstring& fts) const
+	inline Vbool operator <=(const VFileTextSubstring& fts) const
 		{	return (*this < fts) || (*this == fts);  }
-	inline operator >=(const VFileTextSubstring& fts) const
+	inline Vbool operator >=(const VFileTextSubstring& fts) const
 		{	return (*this > fts) || (*this == fts);  }
-	inline operator !=(const VFileTextSubstring& fts) const
+	inline Vbool operator !=(const VFileTextSubstring& fts) const
 		{	return !(*this == fts);  }
 	Vbool Contains(size_t nPos) const;
 	Vbool Contains(const VFileTextSubstring& fts) const;
--- ./htmlpars/htmlpars.h.allpat	Mon Feb 10 10:41:28 2003
+++ ./htmlpars/htmlpars.h	Thu Feb  6 12:24:37 2003
@@ -429,7 +429,7 @@
 	Vbool UnGetEntity(const long ch);
 #ifdef GUESS_HERE
 	void GuessCharSet();
-#endif GUESS_HERE
+#endif 		// GUESS_HERE
 	void SetCharSetAndNotify(long charSet);
 	void SetUndefinedCharSetAndNotify();
 
--- ./nls/windows.h.allpat	Mon Feb 10 10:55:47 2003
+++ ./nls/windows.h	Thu Feb  6 12:05:33 2003
@@ -103,4 +103,4 @@
 } /* extern "C" */
 #endif
 
-#endif /* UNIX_WINDOWS_H */
\ No newline at end of file
+#endif /* UNIX_WINDOWS_H */
--- ./nlstrans/alloc.cpp.allpat	Mon Feb 10 10:42:28 2003
+++ ./nlstrans/alloc.cpp	Tue Dec  3 15:33:46 2002
@@ -1009,7 +1009,7 @@
      *  Allocate it if necessary.
      */
     Index = GETHI4(WChar);
-    if ((pTbl = pTbl4[Index]) == NULL)
+    if ((pTbl = static_cast<P844TBLW>(pTbl4[Index])) == NULL)
     {
         /*
          *  Allocate third table - 16 words.
@@ -1103,7 +1103,7 @@
      *  Allocate it if necessary.
      */
     Index = GETHI4(WChar);
-    if ((pTbl = pTbl4[Index]) == NULL)
+    if ((pTbl = static_cast<P844TBLD>(pTbl4[Index])) == NULL)
     {
         /*
          *  Allocate third table - 16 dwords.
--- ./nlstrans/codepage.cpp.allpat	Mon Feb 10 10:42:57 2003
+++ ./nlstrans/codepage.cpp	Tue Dec  3 15:33:46 2002
@@ -1502,7 +1502,7 @@
 * 07-14-93    t-DanBr    created.
 \***************************************************************************/
 
-GetSBExpansionsTable(
+int GetSBExpansionsTable(
         PCODEPAGE pCP,
         int Size)
 {
@@ -1564,7 +1564,7 @@
 * 07-14-93    t-DanBr    created.
 \***************************************************************************/
 
-GetSBCTypeTables(
+int GetSBCTypeTables(
         PCODEPAGE pCP,
         int Size)
 {
@@ -2759,7 +2759,7 @@
     wDefChar = pCP->DCUniTrans;
     pArr = &(pCP->pWC);
     pTbl4 = (P844ARRAY) (pArr->p8[ GET8(wDefChar) ]);
-    pTbl = pTbl4[ GETHI4(wDefChar) ];
+    pTbl = static_cast<P844TBLW>(pTbl4[ GETHI4(wDefChar) ]);
     pCP->TransUniDefChar = pTbl[ GETLO4(wDefChar) ];
 
     /*
--- ./nlstrans/mbcscode.cpp.allpat	Mon Feb 10 10:43:09 2003
+++ ./nlstrans/mbcscode.cpp	Tue Dec  3 15:33:47 2002
@@ -2027,7 +2027,7 @@
     wDefChar = pCP->DCUniTrans;
     pArr = &(pCP->pWC);
     pTbl4 = (P844ARRAY) (pArr->p8[ GET8(wDefChar) ]);
-    pTbl = pTbl4[ GETHI4(wDefChar) ];
+    pTbl = static_cast<P844TBLW>(pTbl4[ GETHI4(wDefChar) ]);
     pCP->TransUniDefChar = pTbl[ GETLO4(wDefChar) ];
 
     /*
--- ./nlstrans/nlstrans.cpp.allpat	Mon Feb 10 10:43:21 2003
+++ ./nlstrans/nlstrans.cpp	Tue Dec  3 15:33:47 2002
@@ -551,7 +551,7 @@
             pTemp[Ctr] = (WORD)Pos2;
             for (Ctr2 = 0; Ctr2 < TABLESIZE4; Ctr2++)
             {
-                if ((ptr3 = ptr2[Ctr2]) != NULL)
+                if ((ptr3 = static_cast<P844TBLW>(ptr2[Ctr2])) != NULL)
                 {
                     pTemp[Pos2 + Ctr2] = (WORD)Pos3;
                     for (Ctr3 = 0; Ctr3 < TABLESIZE4; Ctr3++)
@@ -670,7 +670,7 @@
             pTemp[Ctr] = (WORD)Pos2;
             for (Ctr2 = 0; Ctr2 < TABLESIZE4; Ctr2++)
             {
-                if ((ptr3 = ptr2[Ctr2]) != NULL)
+                if ((ptr3 = static_cast<P844TBLD>(ptr2[Ctr2])) != NULL)
                 {
                     pTemp[Pos2 + Ctr2] = (WORD)Pos3;
                     for (Ctr3 = 0; Ctr3 < TABLESIZE4; Ctr3++)
--- ./nlstrans/nlstrans.h.allpat	Mon Feb 10 10:43:36 2003
+++ ./nlstrans/nlstrans.h	Wed Feb  5 16:10:49 2003
@@ -24,8 +24,10 @@
 #include <stdarg.h>
 #include <stdio.h>
 
-#if !defined(BSDI) && !defined(FREEBSD)
+#if !defined(BSDI) && !defined(FREEBSD) && !defined(ALPHAOSF)
 #include <malloc.h>
+#else
+#include <stdlib.h>
 #endif
 
 
--- ./nlstrans/unicode.cpp.allpat	Mon Feb 10 10:43:46 2003
+++ ./nlstrans/unicode.cpp	Tue Dec  3 15:33:47 2002
@@ -384,7 +384,7 @@
      */
     if (pMidFour = (P844ARRAY)((S844.p8)[GET8(WChar)]))
     {
-        if (pFour = pMidFour[GETHI4(WChar)])
+      if (pFour = static_cast<P844TBLW>(pMidFour[GETHI4(WChar)]))
             *Value = pFour[GETLO4(WChar)];
         else
             *Value = 0;
--- ./office/stgref/h/dfmsp.hxx.allpat	Mon Feb 10 10:45:03 2003
+++ ./office/stgref/h/dfmsp.hxx	Thu Dec  5 12:02:34 2002
@@ -151,7 +151,11 @@
 #define DfAllocWC(cwc, ppwcs) (*ppwcs = new WCHAR[cwc], \
         (*ppwcs != NULL) ? S_OK: STG_E_INSUFFICIENTMEMORY)
 
-#define DfAllocWCS(pwcs, ppwcs) DfAllocWC(wcslen(pwcs)+1, ppwcs)
+#ifndef DUNIX
+ #define DfAllocWCS(pwcs, ppwcs) DfAllocWC(wcslen(pwcs)+1, ppwcs)
+#else
+#define DfAllocWCS(pwcs, ppwcs) DfAllocWC(localwcslen(pwcs)+1, ppwcs)
+#endif
 
 SCODE DfGetTOD(TIME_T *ptm);
 
@@ -207,13 +211,21 @@
 	if (pb)
 	    memcpy(_ab, pb, cb);
     }
-    void Set(WCHAR const *pwcs) { Set((wcslen(pwcs)+1)*sizeof(WCHAR),
+#ifndef DUNIX
+     void Set(WCHAR const *pwcs) { Set((wcslen(pwcs)+1)*sizeof(WCHAR),
+#else
+    void Set(WCHAR const *pwcs) { Set((localwcslen(pwcs)+1)*sizeof(WCHAR),
+#endif
 				      (BYTE const *)pwcs); }
 
     // Special method for names with prepended character
     void Set(WCHAR const wcLead, WCHAR const *pwcs)
     {
-        _cb = (wcslen(pwcs)+2)*sizeof(WCHAR);
+#ifndef DUNIX
+         _cb = (wcslen(pwcs)+2)*sizeof(WCHAR);
+#else
+        _cb = (localwcslen(pwcs)+2)*sizeof(WCHAR);
+#endif
         *(WCHAR *)_ab = wcLead;
         wcscpy((WCHAR *)_ab+1, pwcs);
     }
--- ./office/stgref/h/dir.hxx.allpat	Mon Feb 10 10:45:11 2003
+++ ./office/stgref/h/dir.hxx	Tue Dec  3 15:33:47 2002
@@ -86,7 +86,7 @@
 //      Notes:      B-flat,C-sharp
 //
 //-----------------------------------------------------------------------
-const CBDIRPAD = DIRENTRYSIZE - sizeof(SPreDirEntry);
+const size_t CBDIRPAD = DIRENTRYSIZE - sizeof(SPreDirEntry);
 
 //  DirEntry bit flags are used for the following private state
 
--- ./office/stgref/h/wchar.h.allpat	Mon Feb 10 10:45:20 2003
+++ ./office/stgref/h/wchar.h	Wed Feb 19 07:23:40 2003
@@ -10,16 +10,54 @@
 **              wide characters
 **--------------------------------------------------------------------------*/
 
-#ifndef __WCHAR__H__
-#define __WCHAR__H__
+#ifndef __WCHAR__H___1
+#define __WCHAR__H___1
 
 #define _WSTRING_DEFINED // prevent incompatibility with <string.h>
 #include <stdlib.h>
 
+#ifdef DUNIX
+#if defined SOLARIS || defined SOLARISX86 || defined FREEBSD || defined SGI
+#include <stddef.h>
+#include <stdio.h>
+#ifdef SGI
+#define __P(x) x
+#define __FILE FILE
+typedef void * __va_list;
+#else
+# if defined __cplusplus && (__GNUC__ >= 3 || __GNUC_MINOR__ >= 8)
+#  define __THROW	throw ()
+# else
+#  define __THROW
+# endif
+# ifndef FREEBSD
+#   define __P(args)	args __THROW
+# endif
+#endif
+#endif		
+#ifndef _WCHAR		/* prevent system wchar.h from being called.  size mismatch */
+#define _WCHAR
+#endif
+typedef int mbstate_t;	
+# ifdef HP700
+   typedef unsigned int wint_t;
+#  define __THROW	throw ()
+#  define __P(args)	args
+# endif
+# ifdef ALPHAOSF
+#   define __P(args)	args
+# endif
+#endif
 #ifndef _MSC_VER
 #define _CRTAPI1
 #endif
 
+# ifdef BSDI
+#include <stdio.h>
+#   define __FILE FILE
+typedef void * __va_list;
+# endif
+
 #if !defined(FLAT) || defined(OLE32)
 #include <stdarg.h>
 
@@ -36,23 +74,40 @@
 #define INTL_PADDING_VALUE 3
 #define INTL_PADDING(cb) (INTL_PADDING_VALUE * (cb))
 
-#if !defined(RS6000)
+#ifdef BSDI
+int       _CRTAPI1 wcscmp(const WCHAR *wsz1, const WCHAR *wsz2);
+int       _CRTAPI1 wcsncmp(const WCHAR *wsz1, const WCHAR *wsz2, size_t count);
+WCHAR * _CRTAPI1 wcsncpy(WCHAR *wsz1, const WCHAR *wsz2, size_t count);
+WCHAR * _CRTAPI1 wcsrchr(const WCHAR * wcs, WCHAR wc);
+#endif
+#if !defined(RS6000) && !defined(BSDI)
 long      _CRTAPI1 wcsatol(const WCHAR *wsz);
 int	  _CRTAPI1 wcsatoi(const WCHAR *wsz);
 WCHAR * _CRTAPI1 wcscat(WCHAR *wsz1, const WCHAR *wsz2);
+  //WCHAR * _CRTAPI1 localwcscat(WCHAR *wsz1, const WCHAR *wsz2);
 WCHAR * _CRTAPI1 wcschr(const WCHAR *wsz1, WCHAR character);
+  //WCHAR * _CRTAPI1 localwcschr(const WCHAR *wsz1, WCHAR character);
 int       _CRTAPI1 wcscmp(const WCHAR *wsz1, const WCHAR *wsz2);
+//int       _CRTAPI1 localwcscmp(const WCHAR *wsz1, const WCHAR *wsz2);
 int       _CRTAPI1 wcsicmp(const WCHAR *wsz1, const WCHAR *wsz2);
 int       _CRTAPI1 wcscoll(const WCHAR * wsz1, const WCHAR * wsz2);
+  //int       _CRTAPI1 localwcscoll(const WCHAR * wsz1, const WCHAR * wsz2);
+extern size_t wcsspn __P ((__const wchar_t *__wcs, __const wchar_t *__accept));
 WCHAR * _CRTAPI1 wcscpy(WCHAR *wsz1, WCHAR const *wsz2);
 WCHAR * _CRTAPI1 wcsitoa(int ival, WCHAR *wsz, int radix);
-size_t    _CRTAPI1 wcslen(WCHAR const *wsz);
+#endif
+size_t    _CRTAPI1 localwcslen(WCHAR const *wsz);
+#ifndef BSDI
+size_t    _CRTAPI1 wcslen(const wchar_t *wsz);
 WCHAR * _CRTAPI1 wcsltoa(long lval, WCHAR *wsz, int radix);
 WCHAR * _CRTAPI1 wcslwr(WCHAR *wsz);
 int       _CRTAPI1 wcsncmp(const WCHAR *wsz1, const WCHAR *wsz2, size_t count);
+  //int       _CRTAPI1 localwcsncmp(const WCHAR *wsz1, const WCHAR *wsz2, size_t count);
 int       _CRTAPI1 wcsnicmp(const WCHAR *wsz1, const WCHAR *wsz2, size_t count);
 WCHAR * _CRTAPI1 wcsncpy(WCHAR *wsz1, const WCHAR *wsz2, size_t count);
+  //WCHAR * _CRTAPI1 localwcsncpy(WCHAR *wsz1, const WCHAR *wsz2, size_t count);
 WCHAR * _CRTAPI1 wcsrchr(const WCHAR * wcs, WCHAR wc);
+  //WCHAR * _CRTAPI1 localwcsrchr(const WCHAR * wcs, WCHAR wc);
 WCHAR * _CRTAPI1 wcsupr(WCHAR *wsz);
 WCHAR * _CRTAPI1 wcswcs(const WCHAR *wsz1, const WCHAR *wsz2);
 size_t _CRTAPI1 wcstosbs( char * s, const WCHAR * pwcs, size_t n);
@@ -75,17 +130,122 @@
 #define wcsnicmp local_wcsnicmp
 WCHAR * _CRTAPI1 wcschr(const WCHAR *wsz1, WCHAR character);
 WCHAR * _CRTAPI1 wcscpy(WCHAR *wsz1, WCHAR const *wsz2);
+#ifndef BSDI
 size_t    _CRTAPI1 wcslen(WCHAR const *wsz);
+#else
+size_t    _CRTAPI1 wcslen(wchar_t const *wsz);
+#endif
 size_t _CRTAPI1 sbstowcs(WCHAR *wcstr, const char *mbstr, size_t count);
 size_t _CRTAPI1 wcstosbs( char * s, const WCHAR * pwcs, size_t n);
 WCHAR * _CRTAPI1 wcscat(WCHAR *wsz1, const WCHAR *wsz2);
 int       _CRTAPI1 wcsnicmp(const WCHAR *wsz1, const WCHAR *wsz2, size_t count);
 #endif
 
+  /*  test  test  test  */
+#ifndef WEOF
+# define WEOF (0xffffffffu)
+#endif
+#if defined FREEBSD || defined BSDI
+  typedef long int wint_t;
+#endif
+#if defined SGI 
+  typedef unsigned int wint_t;
+#endif
+
+#ifndef BSDI
+extern wint_t btowc __P ((int __c)); 
+extern size_t __mbrlen __P ((__const char *__restrict __s, size_t __n,
+			     mbstate_t *__restrict __ps));
+extern size_t mbrlen __P ((__const char *__restrict __s, size_t __n,
+			   mbstate_t *__restrict __ps));
+extern size_t mbrtowc __P ((wchar_t *__restrict __pwc,
+			    __const char *__restrict __s, size_t __n,
+			    mbstate_t *__p));
+extern size_t mbsrtowcs __P ((wchar_t *__restrict __dst,
+			      __const char **__restrict __src,
+			      size_t __len, mbstate_t *__restrict __ps));
+extern int mbsinit __P ((__const mbstate_t *__ps));
+extern size_t wcrtomb __P ((char *__restrict __s, wchar_t __wc,
+			    mbstate_t *__restrict __ps));
+extern size_t wcsrtombs __P ((char *__restrict __dst,
+			      __const wchar_t **__restrict __src,
+			      size_t __len, mbstate_t *__restrict __ps));
+extern long int wcstol __P ((__const wchar_t *__restrict __nptr,
+			     wchar_t **__restrict __endptr, int __base));
+#endif
+  //#ifndef BSDI
+extern size_t wcscspn __P ((__const wchar_t *__wcs,
+			    __const wchar_t *__reject));
+extern wchar_t *wcsncat __P ((wchar_t *__restrict __dest,
+			      __const wchar_t *__restrict __src, size_t __n));
+extern wchar_t *wcspbrk __P ((__const wchar_t *__wcs,
+			      __const wchar_t *__accept));
+  //#endif
+#ifndef BSDI
+extern double wcstod __P ((__const wchar_t *__restrict __nptr,
+			   wchar_t **__restrict __endptr));
+extern unsigned long int wcstoul __P ((__const wchar_t *__restrict __nptr,
+				       wchar_t **__restrict __endptr,
+				       int __base));
+extern wchar_t *wcsstr __P ((__const wchar_t *__haystack,
+			     __const wchar_t *__needle));
+extern wchar_t *wcstok __P ((wchar_t *__restrict __s,
+			     __const wchar_t *__restrict __delim,
+			     wchar_t **__restrict __ptr));
+extern size_t wcsxfrm __P ((wchar_t *__restrict __s1,
+			    __const wchar_t *__restrict __s2, size_t __n));
+  //extern size_t __wcsxfrm_l __P ((wchar_t *__s1, __const wchar_t *__s2,
+  //				size_t __n, __locale_t __loc));
+extern int wctob __P ((wint_t __c));
+/* Search N wide characters of S for C.  */
+#if !defined BSDI && !defined HP700
+extern wchar_t *wmemchr __P ((__const wchar_t *__s, wchar_t __c, size_t __n));
+#endif
+/* Compare N wide characters of S1 and S2.  */
+extern int wmemcmp __P ((__const wchar_t *__restrict __s1,
+			 __const wchar_t *__restrict __s2, size_t __n));
+
+/* Copy N wide characters of SRC to DEST.  */
+extern wchar_t *wmemcpy __P ((wchar_t *__restrict __s1,
+			      __const wchar_t *__restrict __s2, size_t __n));
+
+/* Copy N wide characters of SRC to DEST, guaranteeing
+   correct behavior for overlapping strings.  */
+extern wchar_t *wmemmove __P ((wchar_t *__s1, __const wchar_t *__s2,
+			       size_t __n));
+
+/* Set N wide characters of S to C.  */
+extern wchar_t *wmemset __P ((wchar_t *__s, wchar_t __c, size_t __n));
+#endif
+  /* end test test test */
+#if defined SOLARIS || defined SOLARISX86 || defined SGI || defined BSDI
+extern wint_t fgetwc(__FILE *);
+extern wchar_t *fgetws(wchar_t *, int, __FILE *);
+extern wint_t fputwc(wint_t, __FILE *);
+extern int fputws(const wchar_t *, __FILE *);
+extern wint_t ungetwc(wint_t, __FILE *);
+extern wint_t getwc(__FILE *);
+extern wint_t getwchar(void);
+extern wint_t putwc(wint_t, __FILE *);
+extern wint_t putwchar(wint_t);
+extern int	fwide(__FILE *, int);
+extern int	vfwprintf(__FILE *, const wchar_t *, __va_list);
+extern int	vwprintf(const wchar_t *, __va_list);
+extern int	vswprintf(wchar_t *, size_t, const wchar_t *, __va_list);
+#ifndef BSDI
+extern int	fwprintf(__FILE *, const wchar_t *, ...);
+extern int	fwscanf(__FILE *, const wchar_t *, ...);
+extern int	swprintf(wchar_t *, size_t, const wchar_t *, ...);
+extern int	swscanf(const wchar_t *, const wchar_t *, ...);
+extern int	wprintf(const wchar_t *, ...);
+extern int	wscanf(const wchar_t *, ...);
+#endif
+extern size_t wcsftime(wchar_t *, size_t, const wchar_t *, const struct tm *);
+#endif
 #ifdef __cplusplus
 }
 #endif
 
 #endif /* !defined(FLAT) || defined(OLE32) */
 
-#endif  /* __WCHAR__H__ */
+#endif  /* __WCHAR__H___1 */
--- ./office/stgref/ascii.cxx.allpat	Mon Feb 10 10:45:57 2003
+++ ./office/stgref/ascii.cxx	Tue Dec  3 15:33:47 2002
@@ -80,7 +80,11 @@
     {
         *snbw = pwcs;
         _tbstowcs(*snbw, *snb, strlen(*snb)+1);
+#ifndef DUNIX
         pwcs += wcslen(*snbw)+1;
+#else
+        pwcs += localwcslen(*snbw)+1;
+#endif
     }
     *snbw = NULL;
     return snbwOut;
--- ./office/stgref/funcs.cxx.allpat	Mon Feb 10 10:46:07 2003
+++ ./office/stgref/funcs.cxx	Tue Dec  3 15:33:47 2002
@@ -218,7 +218,11 @@
     WCHAR *pwcsNew;
 
     olDebugOut((DEB_ITRACE, "In  wcsdup(%ws)\n", pwcs));
+#ifndef DUNIX
     pwcsNew = new WCHAR[wcslen(pwcs)+1];
+#else
+    pwcsNew = new WCHAR[localwcslen(pwcs)+1];
+#endif
     if (pwcsNew == NULL)
         return NULL;
     wcscpy(pwcsNew, pwcs);
--- ./office/stgref/refilb.cxx.allpat	Mon Feb 10 10:46:18 2003
+++ ./office/stgref/refilb.cxx	Thu Feb  6 08:10:48 2003
@@ -28,10 +28,15 @@
 #include <unistd.h>
 #endif
 
-#if defined(ALPHAOSF) | defined(RS6000)
+//#if defined(ALPHAOSF) | defined(RS6000)
+#if defined(RS6000)
 static char * realpath(const char *, char *);
 #endif
 
+#if defined(ALPHAOSF) | defined (LINUX)
+extern char *realpath(const char*, char *);
+#endif
+
 #include <stdlib.h>
 #include <ole.hxx>
 
@@ -301,7 +306,8 @@
     return TRUE;
 }
 
-#if defined(ALPHAOSF) | defined(RS6000)
+//#if defined(ALPHAOSF) | defined(RS6000)
+#if defined(RS6000)
 
 
 #include <sys/param.h>
--- ./office/stgref/reftest.cxx.allpat	Mon Feb 10 10:46:29 2003
+++ ./office/stgref/reftest.cxx	Fri Jan 31 14:45:47 2003
@@ -58,7 +58,11 @@
 #if defined(UWARE7)
     va_start(args, fmt);
 #else
+#ifndef DUNIX
     args = va_start(args, fmt);
+#else
+    va_start(args, fmt);
+#endif
 #endif
     fprintf(stderr, "** Fatal error **: ");
     vfprintf(stderr, fmt, args);    
--- ./office/stgref/wchar.c.allpat	Mon Feb 10 10:46:39 2003
+++ ./office/stgref/wchar.c	Tue Dec  3 15:33:47 2002
@@ -7,7 +7,14 @@
 ******************************************************************************
 */
 
+#if defined DUNIX && !defined FREEBSD && !defined SGI && !defined BSDI && !defined HP700
+typedef unsigned int wint_t;	
+#endif
+#ifndef FREEBSD
 #include <wchar.h>
+#else
+#include "./h/wchar.h"
+#endif
 #include <errno.h>
 
 /* This is the errno for Illegal byte sequence.  Not all UNICES define it. */
@@ -175,8 +182,11 @@
 *Exceptions:
 *
 *******************************************************************************/
-
+#ifndef DUNIX
 size_t _CRTAPI1 wcslen(const WCHAR * str)
+#else
+size_t _CRTAPI1 localwcslen(const WCHAR * str)
+#endif
 {
     WCHAR *string = (WCHAR *) str;
 
--- ./rogue/rw/cstring.h.allpat	Mon Feb 10 10:49:51 2003
+++ ./rogue/rw/cstring.h	Thu Feb  6 17:06:38 2003
@@ -248,7 +248,11 @@
 STARTWRAP
 #include <string.h>
 ENDWRAP
-
+#ifdef ALPHAOSF
+#include <iostream>
+#else
+#include <iostream.h>
+#endif
 
 class RWExport RWCRegexp;
 class RWExport RWCString;
--- ./rogue/rw/defs.h.allpat	Mon Feb 10 10:49:57 2003
+++ ./rogue/rw/defs.h	Tue Dec  3 15:33:47 2002
@@ -431,9 +431,11 @@
 inline unsigned long rwmax(unsigned long a, unsigned long b) {return a>b? a : b;}
 inline unsigned long rwmin(unsigned long a, unsigned long b) {return a<b? a : b;}
 
+#ifndef DUNIX
 class _RWCLASSTYPE istream;
 class _RWCLASSTYPE ostream;
 class _RWCLASSTYPE ios;
+#endif
 class RWExport RWvistream;
 class RWExport RWvostream;
 class RWExport RWFile;
--- ./rogue/rw/generic.h.allpat	Mon Feb 10 10:50:04 2003
+++ ./rogue/rw/generic.h	Tue Dec  3 15:33:47 2002
@@ -131,7 +131,7 @@
  *    typedef int(*GPT)(int,char)
  */
 
-extern rwexport genericerror(int,char*);
+extern int rwexport genericerror(int,char*);
 typedef int (*GPT)(int,char*);
 
 #define name2(a,b) _rwname2(a,b) /* to force the args to be evaluated here */
--- ./rogue/rw/locale.h.allpat	Mon Feb 10 10:50:16 2003
+++ ./rogue/rw/locale.h	Tue Dec  3 15:33:47 2002
@@ -146,6 +146,11 @@
 #endif
 #include <time.h>    		/* for struct tm and time_t */
 ENDWRAP
+#ifdef DUNIX
+#ifndef _IO_STREAM_H_
+#include <iostream.h>
+#endif
+#endif
 #include "rw/defs.h"            /* for RWExport */
 #include "rw/cstring.h"    	/* for RWCString */
 #include "rw/zone.h"            /* for RWZone::local() */
--- ./rogue/rw/rwerr.h.allpat	Mon Feb 10 10:50:24 2003
+++ ./rogue/rw/rwerr.h	Tue Dec  3 15:33:47 2002
@@ -271,6 +271,11 @@
 //                                                                      //
 //////////////////////////////////////////////////////////////////////////
 
+#ifdef DUNIX
+#ifndef _IOSTREAM_H_
+#include <iostream.h>
+#endif
+#endif
 // For errors involving streams:
 class RWExport RWStreamErr : public RWExternalErr
 {
--- ./rogue/rw/vstream.h.allpat	Mon Feb 10 10:50:33 2003
+++ ./rogue/rw/vstream.h	Tue Dec  3 15:33:48 2002
@@ -143,6 +143,11 @@
  *
  */
 
+#ifdef DUNIX
+#ifndef _IO_STREAM_H_
+#include <iostream.h>
+#endif
+#endif
 #include "rw/rstream.h"
 
 /*
--- ./rogue/toolsrc/cstrio2.cpp.allpat	Mon Feb 10 10:48:10 2003
+++ ./rogue/toolsrc/cstrio2.cpp	Tue Dec  3 16:08:56 2002
@@ -81,6 +81,7 @@
  *
  */
 
+#include <iostream.h>
 #include "rw/cstring.h"
 #include "rw/rwfile.h"
 #include "rw/vstream.h"
--- ./rogue/toolsrc/cstrngio.cpp.allpat	Mon Feb 10 10:48:21 2003
+++ ./rogue/toolsrc/cstrngio.cpp	Mon Apr  7 12:37:29 2003
@@ -233,8 +233,10 @@
 {
   clobber(getInitialCapacity() * 4);
 
+  int index = 0;
   while (1)
   {
+#if(0)	// this get quits when it finds a blank line.
     strm.get(data_+length(),	        // Address of next byte
 	     capacity()-length()+1,	// Space available (+1 for terminator)
 	     delim);			// Delimiter
@@ -246,11 +248,32 @@
       strm.get();			// eat the delimiter.
       break;
     }
+#endif
+
+    int ch;
+    char *buf = data_+length();		// start here
+    while (1)
+      {
+	if((capacity()-length()) <= 0)  break;	// we need more room
+	ch = strm.get();
+	if(strm.eof() || ch == delim)
+	  break;
+	else
+	  {
+	    *buf++ = ch;
+	    pref()->nchars_++;
+	  }
+      }
+    if(ch == delim) break;
+    if (!strm.good())
+      break;		// Check for EOF or stream failure
+    
     // Delimiter not seen.  Resize and keep going:
     capacity(length() * getResizeIncrement());
+    index = 0;
   }
 
-  data_[length()] = '\0';		// Add null terminator
+  data_[pref()->nchars_ = length()+index] = '\0';  // Add null terminator
 
   return strm;
 }
--- ./rogue/toolsrc/ctassio.cpp.allpat	Mon Feb 10 10:48:32 2003
+++ ./rogue/toolsrc/ctassio.cpp	Tue Dec  3 15:33:48 2002
@@ -76,6 +76,7 @@
  *
  */
 
+#include <iostream.h>
 #include "rw/collass.h"
 #include "rw/rwfile.h"
 #include "rw/vstream.h"
--- ./rogue/toolsrc/disktree.cpp.allpat	Mon Feb 10 10:48:41 2003
+++ ./rogue/toolsrc/disktree.cpp	Tue Dec  3 15:33:48 2002
@@ -238,7 +238,8 @@
   RWDiskTreeNode(unsigned size, RWBTreeOnDisk* tree);
   RWDiskTreeNode(unsigned size, RWBTreeOnDisk* tree, const char* key, 
                  RWstoredValue n);
-  ~RWDiskTreeNode() { delete[] nodeRef; }
+  //  ~RWDiskTreeNode() { delete[] nodeRef; }
+  ~RWDiskTreeNode() { delete[] (char*)nodeRef; }
 
   int		binarySearch(const char* key, RWdiskTreeCompare) const;
   void		initialize();
--- ./rogue/toolsrc/makefile.allpat	Mon Feb 10 10:48:47 2003
+++ ./rogue/toolsrc/makefile	Wed Mar 26 14:09:42 2003
@@ -57,7 +57,12 @@
 ifdef SHARED_LIBRARIES
 SHARED_CPPOPTS=   -fPIC # -D_RWBUILDSHARED
 SHARED_LDOPTS=    -shared
-SHARED_LD_LINK=   g++
+#SHARED_LD_LINK=   g++
+ifeq "$(PLATFORM)" "alpha"
+SHARED_LD_LINK=/pub/dinkumware/$(PLATFORM)-malloc/Compilex -DDUNIX -I/pub/dinkumware/$(PLATFORM)/include
+else
+SHARED_LD_LINK=/pub/dinkumware/$(PLATFORM)/Compilex -DDUNIX -I/pub/dinkumware/$(PLATFORM)/include
+endif
 LIB_SUFFIX=    .1.1.so
 endif
 
@@ -76,7 +81,20 @@
 
 #	The following should be set to whatever command
 #	is necessary to invoke your compiler:
-CPP=		g++
+#CPP=		g++
+ifeq "$(PLATFORM)" "solarisx86"
+CPP=/pub/dinkumware/$(PLATFORM)/Compilex -DDUNIX -fhonor-std -I/pub/dinkumware/$(PLATFORM)/include 
+else
+ifeq "$(PLATFORM)" "sgi"
+CPP=/pub/dinkumware/$(PLATFORM)/Compilex -DDUNIX -fhonor-std -I/pub/dinkumware/$(PLATFORM)/include 
+else
+ifeq "$(PLATFORM)" "alpha"
+CPP=/pub/dinkumware/$(PLATFORM)/Compilex -DDUNIX -I/pub/dinkumware/$(PLATFORM)/include
+else
+CPP=/pub/dinkumware/$(PLATFORM)/Compilex -DDUNIX 
+endif
+endif
+endif
 
 #       Any system dependent flags 
 
@@ -95,6 +113,7 @@
 ifeq "$(PLATFORM)" "sgi"
 SPECIAL=	-fsigned-char
 MACHTYPE=       SGI
+CPPFLAGS += -fhonor-std -I/pub/dinkumware/sgi/include 
 endif
 ifeq "$(PLATFORM)" "bsdi"
 SPECIAL=        -DRW_NO_GLOBAL_TZ -DRW_STRUCT_TM_TZ
@@ -129,6 +148,7 @@
 MACHTYPE=       UWARE7
 endif
 ifeq "$(PLATFORM)" "solarisx86"
+CPPFLAGS += -fhonor-std -I/pub/dinkumware/solarisx86/include
 SPECIAL=       -D_XOPEN_SOURCE
 MACHTYPE=       SOLARISX86
 endif
--- ./rogue/toolsrc/mempool.cpp.allpat	Mon Feb 10 10:48:56 2003
+++ ./rogue/toolsrc/mempool.cpp	Tue Dec  3 15:33:48 2002
@@ -145,7 +145,7 @@
   int slot = (sz >> 1) - 1;
 
   if(slot >= RWMAXPOOLS || nstash[slot] >= RWPOOLSIZE)
-    ::delete p;
+    ::delete (RWMemoryPool*)p;
   else
     stash[slot][nstash[slot]++] = p;
 }
--- ./rogue/toolsrc/message.cpp.allpat	Mon Feb 10 10:49:05 2003
+++ ./rogue/toolsrc/message.cpp	Tue Dec  3 15:33:48 2002
@@ -120,6 +120,10 @@
 
 // Typedefs are the easiest way to make more compilers happy
 // about where the "rwexport" should be:
+#ifndef _IO_STREAM_H_
+#include <iostream.h>
+#endif
+
 typedef ostream& ostreamRef;
 typedef istream& istreamRef;
 
--- ./suid/fpexe.c.allpat	Tue Dec  3 15:33:50 2002
+++ ./suid/fpexe.c	Tue Dec  3 15:33:50 2002
@@ -137,7 +137,7 @@
 #include <sys/mode.h>
 #endif
 
-#if defined(sun) || defined(bsdi) || defined(sgi) || defined(SCO5) || defined(UWARE7)
+#if defined(sun) || defined(bsdi) || defined(sgi) || defined(SCO5) || defined(UWARE7) || defined(FREEBSD) || defined(LINUX)
 extern const char ** environ;
 #endif
 extern int errno;
--- ./suid/makefile.allpat	Mon Feb 10 10:51:27 2003
+++ ./suid/makefile	Tue Dec  3 15:33:50 2002
@@ -31,20 +31,23 @@
 	gcc $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ -Xlinker -static $(LIBS)
 else
 ifeq "$(PLATFORM)" "mips-linux"
-	gcc $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ -Xlinker -static $(LIBS)
+#	$(COMPLD) $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ -Xlinker -static $(LIBS)
+	$(COMPLD) $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ $(LIBS)
 else
-	gcc $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ $(LIBS)
+	$(COMPLD) $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ $(LIBS)
 endif
 endif
 
 $(BINDIR)/fpexe: fpexe.c
 ifeq "$(PLATFORM)" "linux"
-	gcc $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ -Xlinker -static $(LIBS)
+#	$(COMPLD) $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ -Xlinker -static $(LIBS)
+	$(COMPLD) $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ $(LIBS)
 else
 ifeq "$(PLATFORM)" "mips-linux"
-	gcc $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ -Xlinker -static $(LIBS)
+#	$(COMPLD) $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ -Xlinker -static $(LIBS)
+	$(COMPLD) $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ $(LIBS)
 else
-	gcc $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ $(LIBS)
+	$(COMPLD) $(CF_OPT) $(CF_OTHER) $(CF_WARN) $< -o $@ $(LIBS)
 endif
 endif
 
--- ./util/version.h.allpat	Wed Apr  9 16:02:41 2003
+++ ./util/version.h	Wed Apr  9 16:03:06 2003
@@ -126,11 +126,11 @@
 #define V_VERSION_MAJOR 4
 #define V_VERSION_MINOR 0
 #define V_VERSION_PHASE V_VERSION_PHASE_RELEASE
-#define V_VERSION_REV   6811
+#define V_VERSION_REV   6920
 
 #define V_VERSION_MAJOR_STRING "4.0"
-#define V_VERSION_STRING      "4.0.2.6811"
-#define V_VERSION_STRING_ZERO "4.0.2.6811\0"
+#define V_VERSION_STRING      "4.0.2.6920"
+#define V_VERSION_STRING_ZERO "4.0.2.6920\0"
 
 // Set the following to "X" cause "Beta X" to show up appeneded to the version
 // in the Explorer's Help About dialog:
--- ./util/vversion.cpp.allpat	Wed Feb 19 16:46:16 2003
+++ ./util/vversion.cpp	Wed Feb  5 07:33:33 2003
@@ -194,7 +194,11 @@
 {
     // later on we may drop support for some very old versions
     // but now we can upgrade everything
+#ifndef FREEBSD
     return (isBinaryCompatible() || *this < ver);
+#else
+    return (isBinaryCompatible(ver) || *this < ver);
+#endif
 }
 
 /**********************************************************************
--- ./util/vversion.hpp.allpat	Tue Feb 18 13:07:16 2003
+++ ./util/vversion.hpp	Wed Feb 19 07:37:37 2003
@@ -64,7 +64,7 @@
     Vbool operator<=(
         const Vversion &ver) const
                                 { return (!(*this > ver)); }
-#if defined(MIPS_LINUX)
+#if defined(MIPS_LINUX) || defined(FREEBSD)
    // Returns VTRUE if this version is binary compatible with a given release
     Vbool isBinaryCompatible( const Vversion &rel ) const;
 
--- ./util/path.cpp.allpat	Thu Feb 20 12:21:59 2003
+++ ./util/path.cpp	Fri Feb  7 13:51:31 2003
@@ -2225,7 +2225,11 @@
     return 0;
 }
 
+#ifndef ALPHAOSF
 Vstatus *Vpath::stat()
+#else
+Vstatus *Vpath::localstat()
+#endif
 {
     // clear the old status
     ClearStat();
--- ./util/ini.cpp.allpat	Mon Feb 10 10:34:12 2003
+++ ./util/ini.cpp	Fri Jan 17 13:10:30 2003
@@ -580,7 +580,8 @@
     if (st = lockFile.beginTextUpdate( FileName, VTRUE ))
         return (st);
 
-    Vfstream &infile = lockFile.inFile();
+    //    Vfstream &infile = lockFile.inFile();
+    Vistream &infile = lockFile.inFile();
     Vostream &outfile = lockFile.outFile();
 
     outfile.setOutputConversion(VioCvtToLCP);
--- ./util/io.cpp.allpat	Mon Feb 10 10:35:03 2003
+++ ./util/io.cpp	Mon Apr  7 12:39:00 2003
@@ -1,11 +1,11 @@
 //
 // Copyright (c) 1995 Vermeer Technologies, Inc.  All rights reserved.
 //
-// $Source: /cvs/cvs/util/io.cpp,v $
+// $Source: /localwork/vermeer/barb/fp2000-sr1.4/source/util/io.cpp,v $
 //
 // Vistream and Vostream class implementation 
 //
-// $Id: io.cpp,v 1.74 1996/03/30 18:31:51 blumer Exp $
+// $Id: io.cpp,v 1.1 2003/01/20 20:51:33 altman Exp $
 //
 
 #if defined(RS6000)
@@ -14,7 +14,7 @@
 
 #include "util/base.hpp"     /* always included */
 char UTIL_IO_CPP_RCSID[] =
-    "$Id: io.cpp,v 1.74 1996/03/30 18:31:51 blumer Exp $";
+   "$Id: io.cpp,v 1.74 1996/03/30 18:31:51 blumer Exp $";
 
 
 #include "util/io.hpp"       /* for this class */
@@ -29,7 +29,7 @@
 
 #ifdef VUNIX
 #include <strstream.h>       /* for istrstream and ostrstream */
-#include <stdiostream.h>     /* for ostdiostream */
+//#include <stdiostream.h>     /* for ostdiostream */
 #include <unistd.h>          /* for close */
 #include <signal.h>          /* for signal */
 #endif
@@ -77,7 +77,11 @@
 Vistream *Vistream::Cin=NULL;
 
 // several following classes use this routine
+#ifndef SGI
 static void alarm_handler(int /*sig*/)
+#else
+static void alarm_handler(...)
+#endif
 {
     // catch alarm signal and ignore
 }
@@ -173,7 +177,8 @@
 
 #ifdef VUNIX
     if(b)
-        mode |= ios::bin;
+      //        mode |= ios::bin;
+        mode |= ios::binary;
 #endif
 #ifdef VWIN32
     if(b)
@@ -329,7 +334,11 @@
 
         int cmd;
         /* Added initial value to make gcc (no debug) not give warning -tpb */
+#ifndef SGI
         void (*func)(int) = 0;
+#else
+        void (*func)(...) = 0;
+#endif
         if(waitVal == Vwait)
         {
             // set up handler for alarm signal
@@ -703,9 +712,17 @@
         EBuffer->clear( EBuffer->rdstate() | ios::failbit );
     }
     else
-        Ostream->seekp(loc, rel);
+    Ostream->seekp((long int)loc, (_Iosb<int>::_Seekdir)rel);
 }
 
+#ifdef DUNIX
+class Bstreambuf : public strstreambuf
+{
+public:
+  char * bbase() { return pbase(); }
+};
+#endif
+
 // Get file position
 streampos Vostream::tellp()
 {
@@ -715,7 +732,13 @@
         return (0);
     }
     else
-        return Ostream->tellp();
+      {
+#ifdef DUNIX
+	Bstreambuf *buf = (Bstreambuf*)(Ostream->rdbuf());
+	if(buf->bbase() == 0) return 0;
+#endif
+	return Ostream->tellp();
+      }
 }
 
 //
@@ -1411,7 +1434,7 @@
     :Vostream("[array]")
 {
     Ostream = STR_HACK_CAST((ostream*))
-        new VmyOstrstream(buf, size, fileMode(modeStr));
+    new VmyOstrstream((char *)buf, size, (_Iosb<int>::_Openmode)fileMode(modeStr));
 }
 
 Vostrstream::~Vostrstream()
@@ -1461,7 +1484,6 @@
 #endif
 }
 
-
 //
 // VuniqueOstream
 //
@@ -1705,7 +1727,7 @@
         DBuffer->clear( DBuffer->rdstate() | ios::failbit );
     }
     else
-        Istream->seekg(loc, rel);
+  Istream->seekg((long int)loc, (_Iosb<int>::_Seekdir)rel);	
 }
 
 // Get file position
@@ -2051,6 +2073,9 @@
             return;
 
         fstream *fstreamp = new fstream(fd);
+#ifdef DUNIX
+	fstreamp->attach(fd, modeStr);
+#endif
         Istream = STR_HACK_CAST((istream*))fstreamp;
         Ostream = STR_HACK_CAST((ostream*))fstreamp;
         if (Vframework::currentFramework().multiThreaded())
@@ -2419,6 +2444,7 @@
 #endif
 
 
+#ifndef DUNIX
 Vipstream::Vipstream(
     const Vchar *command)
     : Vistream(command)
@@ -2439,7 +2465,8 @@
     FileFp = Vpopen(localCommand, VTEXT("r"));
     if (FileFp)
     {
-        Istream = new istdiostream(FileFp);
+      //        Istream = new istdiostream(FileFp);
+      Istream = new ifstream(fileno(FileFp));
         // Overcome a stupid bug in GCC's iostream library!
 //        Istream->_flags |= (unsigned int)ios::dont_close;
     }
@@ -2467,7 +2494,7 @@
 {
     close();
 }
-
+#endif   // vunix
 
 Vopstream::Vopstream(
     const Vchar *command)
@@ -2493,7 +2520,8 @@
     FileFp = Vpopen(localCommand, VTEXT("w"));
     if (FileFp)
     {
-        Ostream = new ostdiostream(FileFp);
+      //      Ostream = new ostdiostream(FileFp);
+      Ostream = new ofstream(fileno(FileFp));
         // Overcome a stupid bug in GCC's iostream library!
 //        Ostream->_flags |= (unsigned int)ios::dont_close;
     }
@@ -2531,7 +2559,7 @@
 #ifdef VWIN32
 
 #if 0
-O9 RAID 266031/O10 RAID 340723: For security reasons, we must not run any
+/*O9 RAID 266031/O10 RAID 340723: For security reasons, we must not run any
     Win32 file APIs on any file that is mapped to a DOS device, lest we
     hang the server waiting input that will never come.
 
@@ -2545,6 +2573,7 @@
     The source of the function from the RTL is provided here for comparison
     purposes.  -- RandyTh (10/15/2001)
 
+*/
 // begin NT code -- for comparison purposes only
 ULONG
 RtlIsDosDeviceName_Ustr(
@@ -3001,7 +3030,10 @@
 //
 // HISTORY:
 //
-// $Log: /frontpage/server/source/util/io.cpp $
+// $Log: io.cpp,v $
+// $Id: io.cpp,v 1.74 1996/03/30 18:31:51 blumer Exp $
+// Initial revision
+//
 // 
 // 147   4/30/02 8:33p _fpdev
 // (RandyTh) New DOS device fix, backported from O10 RAID 340723.
--- ./util/updtlock.hpp.allpat	Mon Feb 10 10:31:32 2003
+++ ./util/updtlock.hpp	Tue Jan 28 08:57:48 2003
@@ -64,14 +64,15 @@
     Vbool locked(){ return Locked; }
 
     // While an update is in progress, the following are open files
-    Vfstream &inFile() { return InFile; }
+    Vifstream &inFile() { return InFile; }
     Vostream &outFile() { return *Out; }
 
     const Vstring& outFilePath() { return OutFilePath.asString(); }
 
 protected:
     Vbool     Locked;
-    Vfstream  InFile;
+  //    Vfstream  InFile;
+    Vifstream  InFile;
     Vpath     InFilePath;
     Vbool     InFileExisted;
     Vostream* Out;
@@ -119,7 +120,8 @@
 
     // disallow
     VupdateLock( const VupdateLock& );
-    operator=( const VupdateLock& );
+  //    operator=( const VupdateLock& );
+    const VupdateLock& operator=( const VupdateLock& );
 };
 
 inline Vstatus *VupdateLock::beginTextUpdate(
--- ./util/circbuf.hpp.allpat	Mon Feb 10 10:33:24 2003
+++ ./util/circbuf.hpp	Thu Feb  6 12:12:07 2003
@@ -71,4 +71,4 @@
 // 
 // 1     6/04/96 8:44a Tadc
 // Added circbuf.[ch]pp - VcircularBuffer class.
-//
\ No newline at end of file
+//
--- ./util/fpprogress.hpp.allpat	Mon Feb 10 10:33:35 2003
+++ ./util/fpprogress.hpp	Thu Feb  6 12:06:34 2003
@@ -24,4 +24,4 @@
     Vuint32         dwProgress);        // either byte count or percent
 
 
-#endif /* UTIL_FPPROGRESS_HPP */
\ No newline at end of file
+#endif /* UTIL_FPPROGRESS_HPP */
--- ./util/gdimtest.cpp.allpat	Mon Feb 10 10:33:47 2003
+++ ./util/gdimtest.cpp	Tue Dec  3 15:33:52 2002
@@ -26,8 +26,10 @@
 void Vtest::run()
 {
 	{
+		char text[] = "tests/srcimg.gif";
 		VDIAG(0,0, VTEXT("Opening source image ...\n"));
-		VgdImage imSrc("tests/srcimg.gif",VgdfileGif);
+		//		VgdImage imSrc("tests/srcimg.gif",VgdfileGif);
+		VgdImage imSrc(&text[0],VgdfileGif);
 		if(imSrc.IsEmpty())
 		{
 			VDIAG(0,0, VTEXT("Failed to open source image.\n"));
@@ -36,7 +38,9 @@
 		}
 		
 		VDIAG(0,0, VTEXT("Opening overlay image ...\n"));
-		VgdImage imOvr("tests/ovrimg.gif",VgdfileGif);
+		//		VgdImage imOvr("tests/ovrimg.gif",VgdfileGif);
+		char text1[] = "tests/ovrimg.gif";
+		VgdImage imOvr(&text1[0],VgdfileGif);
 		if(imOvr.IsEmpty())
 		{
 			VDIAG(0,0, VTEXT("Failed to open overlay image.\n"));
@@ -56,8 +60,10 @@
 			return;
 		}
 		
+		char text2[] = "tests/cmpimg.gif";
 		VDIAG(0,0, VTEXT("Loading original composite image ...\n"));
-		VgdImage imCmp1("tests/cmpimg.gif",VgdfileGif);
+		//		VgdImage imCmp1("tests/cmpimg.gif",VgdfileGif);
+		VgdImage imCmp1(&text2[0],VgdfileGif);
 		if(imCmp1.IsEmpty())
 		{
 			VDIAG(0,0, VTEXT("Failed to open original composite image.\n"));
@@ -89,7 +95,9 @@
 	{
 		// test animated gif overlays
 		VDIAG(0,0, VTEXT("Opening animated source image ...\n"));
-		VgdImage imAnimated("tests/aniimg.gif",VgdfileGif);
+		//		VgdImage imAnimated("tests/aniimg.gif",VgdfileGif);
+		char text4[] = "tests/aniimg.gif";
+		VgdImage imAnimated(&text4[0],VgdfileGif);
 		if(imAnimated.IsEmpty())
 		{
 			VDIAG(0,0, VTEXT("Failed to open animated source image.\n"));
@@ -98,7 +106,9 @@
 		}
 		
 		VDIAG(0,0, VTEXT("Opening overlay mask ...\n"));
-		VgdImage imMask("tests/maskimg.gif",VgdfileGif);
+		//		VgdImage imMask("tests/maskimg.gif",VgdfileGif);
+		char text5[] = "tests/maskimg.gif";
+		VgdImage imMask(&text5[0],VgdfileGif);
 		if(imMask.IsEmpty())
 		{
 			VDIAG(0,0, VTEXT("Failed to open overlay mask.\n"));
@@ -119,7 +129,8 @@
 		}
 		
 		VDIAG(0,0, VTEXT("Loading original animated composite image ...\n"));
-		VgdImage imCmpAni1("tests/cmpanimg.gif",VgdfileGif);
+		char text6[] = "tests/cmpanimg.gif";
+		VgdImage imCmpAni1(&text6[0],VgdfileGif);
 		if(imCmpAni1.IsEmpty())
 		{
 			VDIAG(0,0, VTEXT("Failed to open original animated composite image.\n"));
@@ -191,7 +202,8 @@
         }
 
 		VDIAG(0,0, VTEXT("Opening overlay mask ...\n"));
-		VgdImage imMask("tests/maskimg.gif",VgdfileGif);
+		char text7[] = "tests/maskimg.gif";
+		VgdImage imMask(&text7[0],VgdfileGif);
 		if(imMask.IsEmpty())
 		{
 			VDIAG(0,0, VTEXT("Failed to open overlay mask.\n"));
--- ./util/htmlstrp.hpp.allpat	Mon Feb 10 10:34:03 2003
+++ ./util/htmlstrp.hpp	Thu Feb  6 12:11:11 2003
@@ -44,4 +44,4 @@
 // 
 // 1     4/20/97 11:46p Tadc
 // Files for VhtmlTagStripper class.
-//
\ No newline at end of file
+//
--- ./util/ivector.hpp.allpat	Mon Feb 10 10:35:16 2003
+++ ./util/ivector.hpp	Thu Feb  6 12:23:40 2003
@@ -33,7 +33,7 @@
 #undef RWGExport
 #define RWGExport _declspec(dllimport)
 
-#endif UTIL_IVECTOR_HXX
+#endif 		// UTIL_IVECTOR_HXX
 
 
 //
--- ./util/langcpmap.hpp.allpat	Mon Feb 10 10:35:30 2003
+++ ./util/langcpmap.hpp	Thu Feb  6 12:10:06 2003
@@ -48,4 +48,4 @@
 // created.
 // mapping functions from LCID to RPC1766-compliant language id and vice
 // versa and default codepage information
-//
\ No newline at end of file
+//
--- ./util/lockfile.hpp.allpat	Mon Feb 10 10:35:41 2003
+++ ./util/lockfile.hpp	Tue Dec  3 15:33:52 2002
@@ -41,7 +41,8 @@
 
     // disallow
     VlockFile( const VlockFile& );
-    operator=( const VlockFile& );
+  //    operator=( const VlockFile& );
+    const VlockFile operator=( const VlockFile& );
 
 };
 
--- ./util/makefile.allpat	Mon Feb 10 10:36:04 2003
+++ ./util/makefile	Fri Mar 14 07:32:19 2003
@@ -521,6 +521,11 @@
 ifneq "$(PLATFORM)" "sco5"
 ifneq "$(PLATFORM)" "gemini"
 ifneq "$(PLATFORM)" "linux"
+ifneq "$(PLATFORM)" "solaris"
+ifneq "$(PLATFORM)" "solarisx86"
+ifneq "$(PLATFORM)" "sgi"
+ifneq "$(PLATFORM)" "hp700"
+ifneq "$(PLATFORM)" "alpha"
 $(BINDIR)/rpcid$O: $(BINDIR)/rpcid.cc
 	g++ $(CF_OPT) $(CF_OTHER) $(CF_WARN) -c $< -o $@
 $(BINDIR)/svector$O: $(BINDIR)/svector.cc
@@ -531,6 +536,11 @@
 	g++ $(CF_OPT) $(CF_OTHER) $(CF_WARN) -c $< -o $@
 $(BINDIR)/vmdict$O: $(BINDIR)/vmdict.cc
 	g++ $(CF_OPT) $(CF_OTHER) $(CF_WARN) -c $< -o $@
+endif
+endif
+endif
+endif
+endif
 endif
 endif
 endif
--- ./util/navbits.hpp.allpat	Mon Feb 10 10:36:15 2003
+++ ./util/navbits.hpp	Thu Feb  6 12:08:57 2003
@@ -89,4 +89,4 @@
 // 
 // 1     3/24/97 5:44p Tadc
 // Added VnavBits class, for tracking navigational dependencies.
-//
\ No newline at end of file
+//
--- ./util/ostypes.h.allpat	Mon Feb 10 10:36:29 2003
+++ ./util/ostypes.h	Thu Jan 23 12:00:46 2003
@@ -42,6 +42,8 @@
 typedef unsigned char  Vuint8;     /* Unsigned integer at least 8 bits */
 typedef Vuint16 Vwchar;            /* Vwchar = Unicode character */
 
+typedef struct tm      Vtm;        /* struct tm definition */
+
 /*
  * Use this for booleans:
  */
--- ./util/qdict.cpp.allpat	Mon Feb 10 10:36:41 2003
+++ ./util/qdict.cpp	Tue Dec  3 15:33:53 2002
@@ -296,7 +296,7 @@
 {
 	if (size == 0)
 	{
-		delete[] m_data;
+		delete[] (VqdictRep*)m_data;
 		m_data = 0;
 	}
 	else if (size > getSize())
--- ./util/statvec.hpp.allpat	Mon Feb 10 10:37:02 2003
+++ ./util/statvec.hpp	Thu Feb  6 12:42:33 2003
@@ -22,7 +22,7 @@
 #undef RWGExport
 #define RWGExport _declspec(dllimport)
 
-#endif UTIL_SVECTOR_HXX
+#endif 		// UTIL_SVECTOR_HXX
 
 
 //
--- ./util/strucinf.hpp.allpat	Mon Feb 10 10:37:15 2003
+++ ./util/strucinf.hpp	Tue Dec  3 15:33:53 2002
@@ -142,7 +142,7 @@
     static const Vchar* const mkeyNonNavPage();
 
 private:
-    friend VStructureModification;
+    friend class VStructureModification;
 
     static VElementID m_eidNext;   // temp id used with helper fcns
 
--- ./util/svector.hpp.allpat	Mon Feb 10 10:37:33 2003
+++ ./util/svector.hpp	Thu Feb  6 12:22:44 2003
@@ -25,7 +25,7 @@
 #undef RWGExport
 #define RWGExport _declspec(dllimport)
 
-#endif UTIL_SVECTOR_HXX
+#endif 		// UTIL_SVECTOR_HXX
 
 
 //
--- ./util/tristate.hpp.allpat	Mon Feb 10 10:37:45 2003
+++ ./util/tristate.hpp	Thu Feb  6 12:07:39 2003
@@ -29,4 +29,4 @@
 // 1     7/10/96 11:31p Tadc
 // Tristate variable class - useful for Booleans which can have a third
 // (unset or NA) state.
-//
\ No newline at end of file
+//
--- ./util/updtlock.cpp.allpat	Mon Feb 10 10:38:13 2003
+++ ./util/updtlock.cpp	Fri Mar 14 07:42:40 2003
@@ -118,7 +118,8 @@
                                    : (!InFileReadOnly
                                           ? Vlock_exclusiveReally
                                           : Vlock_shareReally);
-    if (st = InFile.open(InFilePath.name(), ioMode, mode, lockType))
+    //  if (st = InFile.open(InFilePath.name(), ioMode, mode, lockType))
+    if (st = InFile.open(InFilePath.asString(), ioMode, lockType))
     {
         if (Lock)
             LockFile.unlock();
@@ -328,7 +329,6 @@
           InFilePath.asString().data(), (int)Lock);
 
     Vassert( locked() );
-
     Vstatus *st = 0;
     if (CommitState == Vuncommitted)
     {
@@ -561,7 +561,15 @@
     InFileExisted = VTRUE;
 
     Vstatus* st;
-    if (st = InFile.open(InFilePath.name(), ioMode, mode))
+    Vbool ReadOnly = roOK && InFileExisted &&
+        !InFilePath.fileModeCheck( Vpath::VmodeFileRW );
+    const Vlock_type lockType = !lock
+                                   ? Vlock_none
+                                   : (!ReadOnly
+                                          ? Vlock_exclusiveReally
+                                          : Vlock_shareReally);
+    //  if (st = InFile.open(InFilePath.name(), ioMode, mode))
+    if (st = InFile.open(InFilePath.name(),  ioMode, lockType))
     {
         if (InFilePath.exists())
             return st;
@@ -815,7 +823,7 @@
     }
 
     if (st = InFile.close())
-        goto write_error;
+       goto write_error;
 
     // Our approach on Unix is to always write to a temp file, then
     // rename it to the original file unless VupdtKeepTempFile is set
--- ./util/urllist.hpp.allpat	Mon Feb 10 10:38:38 2003
+++ ./util/urllist.hpp	Thu Feb  6 12:23:09 2003
@@ -96,7 +96,7 @@
 };
 
 
-#endif UTIL_URLLIST_HPP
+#endif 		// UTIL_URLLIST_HPP
 
 //
 // HISTORY:
--- ./util/urlmap.hpp.allpat	Mon Feb 10 10:38:51 2003
+++ ./util/urlmap.hpp	Thu Feb  6 12:23:25 2003
@@ -175,7 +175,7 @@
     VdictIter* PVdIter;
 };
 
-#endif UTIL_URLMAP_HPP
+#endif 		// UTIL_URLMAP_HPP
 
 //
 // HISTORY:
--- ./util/vdict.hpp.allpat	Mon Feb 10 10:39:06 2003
+++ ./util/vdict.hpp	Fri Feb 21 07:44:14 2003
@@ -24,4 +24,4 @@
 #undef RWGExport
 #define RWGExport _declspec(dllimport)
 
-#endif UTIL_VDICT_HXX
+#endif 	// UTIL_VDICT_HXX
--- ./util/vector.hpp.allpat	Mon Feb 10 10:39:16 2003
+++ ./util/vector.hpp	Thu Feb  6 12:22:25 2003
@@ -400,7 +400,7 @@
     return (out);                                                           \
 }
 
-#endif UTIL_VECTOR_HXX
+#endif 		// UTIL_VECTOR_HXX
 
 
 //
--- ./util/vmdict.hpp.allpat	Mon Feb 10 10:39:28 2003
+++ ./util/vmdict.hpp	Thu Feb  6 12:23:51 2003
@@ -29,4 +29,4 @@
     VpmdictVector &vpmdict,
     PfnMIFilter pfnFilter);
 
-#endif UTIL_VMDICT_HXX
+#endif 		// UTIL_VMDICT_HXX
--- ./util/vurldir.hpp.allpat	Mon Feb 10 10:39:40 2003
+++ ./util/vurldir.hpp	Thu Feb  6 12:41:46 2003
@@ -24,4 +24,4 @@
 #undef RWGExport
 #define RWGExport _declspec(dllimport)
 
-#endif UTIL_VURLDIR_HXX
+#endif 		// UTIL_VURLDIR_HXX
--- ./util/vvector.hpp.allpat	Mon Feb 10 10:39:54 2003
+++ ./util/vvector.hpp	Thu Feb  6 12:42:10 2003
@@ -23,7 +23,7 @@
 #undef RWGExport
 #define RWGExport _declspec(dllimport)
 
-#endif UTIL_VVECTOR_HPP
+#endif 		// UTIL_VVECTOR_HPP
 
 
 //
--- ./util/wstring.cpp.allpat	Mon Feb 10 10:40:07 2003
+++ ./util/wstring.cpp	Tue Dec  3 15:33:55 2002
@@ -456,7 +456,9 @@
 	Vwchar* pOld = IsNull() ? 0 : GetData();
 
 	// first, count how big of a buffer is needed
-	va_list argList1 = *pargList;
+	//	va_list argList1 = *pargList;
+	va_list argList1;
+        argList1 = *pargList;
 	Vuint32 nNewLen = Vwstrlen(pwc1);
 	const Vwchar* pwcArg = pwc2;
 	while (pwcArg)
@@ -471,7 +473,9 @@
 	Vwchar* pwcPart = m_pwcData;
 
 	// make another pass filling the buffer
-	va_list argList2 = *pargList;
+	//	va_list argList2 = *pargList;
+	va_list argList2;
+	argList2=*pargList;
 	pwcPart = CopyStep(pwcPart, pwc1, Vwstrlen(pwc1));
 	pwcArg = pwc2;
 	while (pwcArg)
--- ./util/path.hpp.allpat	Thu Feb 20 12:27:12 2003
+++ ./util/path.hpp	Thu Feb 20 12:27:14 2003
@@ -446,7 +446,11 @@
         Vbool overwrite = VFALSE);
 
     // Force a stat call, return error status
-    Vstatus *stat();
+#ifndef ALPHAOSF
+  Vstatus *stat();
+#else
+  Vstatus *localstat();
+#endif
 
     // Return Vstatus from last stat call
     Vstatus *status();
--- ./util/cssdict.hpp.allpat	Fri Feb 21 07:45:07 2003
+++ ./util/cssdict.hpp	Fri Feb 21 07:45:21 2003
@@ -78,5 +78,5 @@
 
 
 
-#endif UTIL_VCSSDICT
+#endif 		// UTIL_VCSSDICT
 
--- ./util/tvector.hpp.allpat	Fri Feb 21 07:45:39 2003
+++ ./util/tvector.hpp	Fri Feb 21 07:45:51 2003
@@ -26,5 +26,5 @@
 #define RWGExport _declspec(dllimport)
 
 
-#endif UTIL_TVECTOR_HPP
+#endif 		// UTIL_TVECTOR_HPP
 
--- ./util/io.hpp.allpat	Fri Mar 14 09:03:09 2003
+++ ./util/io.hpp	Wed Mar 26 13:57:27 2003
@@ -12,7 +12,11 @@
 #ifndef UTIL_IO_HPP
 #define UTIL_IO_HPP
 
+#ifndef ALPHAOSF
 #include <iostream.h>     /* for istream and ostream */
+#else
+#include <iostream>
+#endif
 
 #include "util/osstdarg.hpp"
 
--- ./wais/private/trie.h.allpat	Mon Feb 10 10:56:57 2003
+++ ./wais/private/trie.h	Tue Dec  3 15:33:55 2002
@@ -24,6 +24,7 @@
   struct _trie **table;
 } trie;
 
+#ifndef DUNIX
 typedef struct _allocator {
   char* tofree[MAX_BLOCKS];
   int blocks_allocated;
@@ -32,7 +33,6 @@
   int size;
   void (*dispose)();
 } allocator;
-
 typedef struct _trie_allocator {
   allocator* tries;
   allocator* trie_tables;
@@ -41,6 +41,25 @@
 char* fast_alloc _AP((allocator* x));
 void  fast_free _AP((allocator* x));
 allocator* make_allocator _AP((int item_size,void (*dispose)(trie *item)));
+#else			// changing name to fix name collision bha 10/24/02
+typedef struct _allocator {
+  char* tofree[MAX_BLOCKS];
+  int blocks_allocated;
+  char* next_location;
+  int items_left;
+  int size;
+  void (*dispose)();
+} allocator1;
+typedef struct _trie_allocator {
+  allocator1* tries;
+  allocator1* trie_tables;
+} trie_allocator;
+
+char* fast_alloc _AP((allocator1* x));
+void  fast_free _AP((allocator1* x));
+allocator1* make_allocator _AP((int item_size,void (*dispose)(trie *item)));
+#endif
+
 void dispose_trie_allocator _AP((trie_allocator* alloc));
 trie_allocator* make_trie_allocator();
 
--- ./wais/private/walpha.h.allpat	Fri Feb 21 07:47:41 2003
+++ ./wais/private/walpha.h	Fri Feb 21 07:47:59 2003
@@ -234,4 +234,4 @@
 /* #undef HAVE_LIBSUN */
 
 
-#endif WAIS_ALPHA_H
+#endif 	// WAIS_ALPHA_H
--- ./wais/private/whp700.h.allpat	Fri Feb 21 13:35:18 2003
+++ ./wais/private/whp700.h	Fri Feb 21 13:35:20 2003
@@ -234,4 +234,4 @@
 /* #undef HAVE_LIBSUN */
 
 
-#endif WAIS_SOLARIS_H
+#endif 	// WAIS_SOLARIS_H
--- ./wais/makefile.allpat	Mon Feb 10 10:56:10 2003
+++ ./wais/makefile	Thu Feb  6 12:00:17 2003
@@ -210,17 +210,17 @@
 ifneq ($(PLATFORM),sunos)
 $(BINDIR)/waisindex: $(BINDIR)/waisindex.o $(MANUALTESTOBJS) $(LIBRARY) \
                      $(DLIBS)
-	$(CXX) $(LD_PROF) $(BINDIR)/waisindex.o $(MANUALTESTOBJS) $(LIBRARY) \
+	$(COMPMULT) $(LD_PROF) $(BINDIR)/waisindex.o $(MANUALTESTOBJS) $(LIBRARY) \
                                   $(DLIBS) -o $(BINDIR)/waisindex $(SYSLIBS)
 
 $(BINDIR)/waislook: $(BINDIR)/waislook.o $(MANUALTESTOBJS) $(LIBRARY) \
                     $(DLIBS)
-	$(CXX) $(LD_PROF) $(BINDIR)/waislook.o $(MANUALTESTOBJS) $(LIBRARY) \
+	$(COMPMULT) $(LD_PROF) $(BINDIR)/waislook.o $(MANUALTESTOBJS) $(LIBRARY) \
                                   $(DLIBS) -o $(BINDIR)/waislook $(SYSLIBS)
 endif # platform != sunos
 ifeq "$(PLATFORM)" "alpha"
 $(BINDIR)/vface$O: vface.cpp
-	g++ $(CXXFLAGS) -O0 -c $< -o $@
+	$(CXX) $(CXXFLAGS) -O0 -c $< -o $@
 endif
 endif # UNIX
 
--- ./wais/trie.c.allpat	Mon Feb 10 10:56:17 2003
+++ ./wais/trie.c	Thu Dec  5 16:11:52 2002
@@ -105,6 +105,7 @@
 /*
  * make a new allocator 
  */
+#ifndef DUNIX
 allocator* make_allocator(item_size,free_func) 
 int item_size;
 void (*free_func)(trie*);
@@ -118,12 +119,31 @@
   tmp->dispose = free_func;
   return tmp;
 }
+#else
+allocator1* make_allocator(item_size,free_func)
+int item_size;
+void (*free_func)(trie*);
+{
+  allocator1* tmp;
+  if (!(tmp = (allocator1 *)s_malloc(sizeof(allocator1)))) {
+    return 0L;
+  }
+ 
+  tmp->size=item_size;
+  tmp->dispose = free_func;
+  return tmp;
+}
+#endif
 
 /*
  * dispose of an allocator
  */
 void fast_free(alloc)
+#ifndef DUNIX
 allocator* alloc;
+#else
+allocator1* alloc;
+#endif
 {
   
   char *block;
@@ -147,7 +167,11 @@
  */
 
 char* fast_alloc(alloc)
+#ifndef DUNIX
 allocator* alloc;
+#else
+allocator1* alloc;
+#endif
 {
   
   char* tmp;
@@ -232,8 +256,12 @@
 }
 
 trie ** new_trie_table(alloc)
-allocator* alloc; {
-
+#ifndef DUNIX
+allocator* alloc; 
+#else
+allocator1* alloc;
+#endif
+{
   trie** tmp;
 
   tmp=(trie **)fast_alloc(alloc);
--- ./wel/docvid.cpp.allpat	Thu Feb 20 11:01:37 2003
+++ ./wel/docvid.cpp	Thu Feb 13 14:46:50 2003
@@ -997,7 +997,11 @@
 					}
 
 					// get byte length
+#if !defined(ALPHAOSF) & !defined(HP700)
 					streampos nbytes = istr.tellg();
+#else
+					int nbytes = istr.tellg();
+#endif
 
 					// seek to beginning of file
 					istr.seekg(0, ios::beg);
--- ./wel/texttest.oux.linux.allpat	Mon Feb 10 10:11:04 2003
+++ ./wel/texttest.oux.linux	Tue Dec  3 15:34:01 2002
@@ -1,3 +1,406 @@
+Checking VServer::currentVserver()... Done
+Checking VService constructor... Done
+Checking VtextSource::enumerate... Done
+Checking VtextSource::createTextSource... Done
+Checking VtextSource::enumerate... Done
+Checking VtextSource constructor... Done
+Checking VtextSource constructor... Done
+Checking VtextSource::enumerateTables... Done
+Checking VtextSource::createTable... Done
+Checking VtextSource::enumerateTables... Done
+Checking VtextSource::enumerateFields... 
+Rows: 12
+Cols: 2
+(0, 0): Weight
+(0, 1): 2
+(1, 0): DocumentId
+(1, 1): 2
+(2, 0): Filename
+(2, 1): 0
+(3, 0): Url
+(3, 1): 0
+(4, 0): Headline
+(4, 1): 0
+(5, 0): TypeName
+(5, 1): 0
+(6, 0): TimeStamp
+(6, 1): 1
+(7, 0): NumberOfLines
+(7, 1): 2
+(8, 0): DocumentLength
+(8, 1): 2
+(9, 0): DocumentK
+(9, 1): 3
+(10, 0): BestCharacter
+(10, 1): 2
+(11, 0): BestLine
+(11, 1): 2
+Done
+Checking VtextSource::count... 
+Table has 0 indexed files/documents
+Table has 0 documents in the WAIS index
+Done
+Checking VtextSource::query... 
+Rows: 0
+Cols: 0
+Done
+Checking VtextSource::stopIndexing+addToIndex... Done
+Checking VtextSource::count... 
+Table has 1 indexed files/documents
+Table has 0 documents in the WAIS index
+Done
+Checking VtextSource::query... 
+Rows: 0
+Cols: 0
+Done
+Checking VtextSource::startIndexing+addToIndex... Done
+Checking VtextSource::count... 
+Table has 1 indexed files/documents
+Table has 1 documents in the WAIS index
+Done
+Checking VtextSource::query... 
+Rows: 1
+Cols: 3
+(0, 0): 500
+(0, 1): /TextTest/texttest.dat/orghome.htm
+(0, 2): Org Chart
+Done
+Checking VtextSource::addToIndex... Done
+Checking VtextSource::count... 
+Table has 42 indexed files/documents
+Table has 42 documents in the WAIS index
+Done
+Checking VtextSource::query... 
+Rows: 1
+Cols: 3
+(0, 0): 500
+(0, 1): /TextTest/texttest.dat/orghome.htm
+(0, 2): Org Chart
+Done
+Checking fancy VtextSource::query... 
+Rows: 27
+Cols: 10
+(0, 0): 0
+(0, 1): 0
+(0, 2): 4549
+(0, 3): 1
+(0, 4): 05/06/96 10:12:50
+(0, 5): URL
+(0, 6): Glossary
+(0, 7): /TextTest/texttest.dat/pw-basic.htm
+(0, 8): 20
+(0, 9): 1062
+(1, 0): 0
+(1, 1): 0
+(1, 2): 4594
+(1, 3): 1
+(1, 4): 05/06/96 10:12:54
+(1, 5): URL
+(1, 6): Glossary
+(1, 7): /TextTest/texttest.dat/pw-spar2.htm
+(1, 8): 27
+(1, 9): 990
+(2, 0): 0
+(2, 1): 0
+(2, 2): 4594
+(2, 3): 1
+(2, 4): 05/06/96 10:12:54
+(2, 5): URL
+(2, 6): Glossary
+(2, 7): /TextTest/texttest.dat/pw-spar3.htm
+(2, 8): 28
+(2, 9): 990
+(3, 0): 0
+(3, 1): 0
+(3, 2): 4594
+(3, 3): 1
+(3, 4): 05/06/96 10:12:56
+(3, 5): URL
+(3, 6): Glossary
+(3, 7): /TextTest/texttest.dat/pw-spar4.htm
+(3, 8): 29
+(3, 9): 990
+(4, 0): 0
+(4, 1): 0
+(4, 2): 4594
+(4, 3): 1
+(4, 4): 05/06/96 10:12:56
+(4, 5): URL
+(4, 6): Glossary
+(4, 7): /TextTest/texttest.dat/pw-spar5.htm
+(4, 8): 30
+(4, 9): 990
+(5, 0): 0
+(5, 1): 0
+(5, 2): 9427
+(5, 3): 1
+(5, 4): 05/06/96 10:12:54
+(5, 5): URL
+(5, 6): HyperText Markup Language (HTML) Basics
+(5, 7): /TextTest/texttest.dat/pw-spar1.htm
+(5, 8): 26
+(5, 9): 868
+(6, 0): 0
+(6, 1): 0
+(6, 2): 1562
+(6, 3): 1
+(6, 4): 05/06/96 10:13:02
+(6, 5): URL
+(6, 6): Widget Employee Services
+(6, 7): /TextTest/texttest.dat/services.htm
+(6, 8): 37
+(6, 9): 857
+(7, 0): 0
+(7, 1): 0
+(7, 2): 2124
+(7, 3): 1
+(7, 4): 05/06/96 10:12:44
+(7, 5): URL
+(7, 6): News and Calendars
+(7, 7): /TextTest/texttest.dat/news.htm
+(7, 8): 14
+(7, 9): 773
+(8, 0): 0
+(8, 1): 0
+(8, 2): 410
+(8, 3): 1
+(8, 4): 05/06/96 10:12:38
+(8, 5): URL
+(8, 6): Global History
+(8, 7): /TextTest/texttest.dat/globhist.htm
+(8, 8): 6
+(8, 9): 760
+(9, 0): 0
+(9, 1): 0
+(9, 2): 5096
+(9, 3): 1
+(9, 4): 05/06/96 10:13:00
+(9, 5): URL
+(9, 6): Workgroup Web
+(9, 7): /TextTest/texttest.dat/pw-wgweb.htm
+(9, 8): 33
+(9, 9): 743
+(10, 0): 0
+(10, 1): 0
+(10, 2): 300
+(10, 3): 1
+(10, 4): 05/06/96 10:12:50
+(10, 5): URL
+(10, 6): Requires access to the Internet
+(10, 7): /TextTest/texttest.dat/pw-extrn.htm
+(10, 8): 21
+(10, 9): 632
+(11, 0): 0
+(11, 1): 0
+(11, 2): 488
+(11, 3): 1
+(11, 4): 05/06/96 10:13:00
+(11, 5): URL
+(11, 6): Web Surfing
+(11, 7): /TextTest/texttest.dat/pw-wsurf.htm
+(11, 8): 34
+(11, 9): 627
+(12, 0): 0
+(12, 1): 0
+(12, 2): 2691
+(12, 3): 1
+(12, 4): 05/06/96 10:12:52
+(12, 5): URL
+(12, 6): PATHWORKS for DOS and Windows
+(12, 7): /TextTest/texttest.dat/pw-pthwk.htm
+(12, 8): 24
+(12, 9): 511
+(13, 0): 0
+(13, 1): 0
+(13, 2): 4227
+(13, 3): 1
+(13, 4): 05/06/96 10:12:56
+(13, 5): URL
+(13, 6): Starting Points on the Web
+(13, 7): /TextTest/texttest.dat/pw-stpnt.htm
+(13, 8): 31
+(13, 9): 439
+(14, 0): 0
+(14, 1): 0
+(14, 2): 396
+(14, 3): 1
+(14, 4): 05/06/96 10:12:38
+(14, 5): URL
+(14, 6): Fred Adams
+(14, 7): /TextTest/texttest.dat/fa.htm
+(14, 8): 5
+(14, 9): 384
+(15, 0): 0
+(15, 1): 0
+(15, 2): 1381
+(15, 3): 1
+(15, 4): 05/06/96 10:12:52
+(15, 5): URL
+(15, 6): Introduction to Mosaic and Web Surfing
+(15, 7): /TextTest/texttest.dat/pw-intro.htm
+(15, 8): 23
+(15, 9): 335
+(16, 0): 0
+(16, 1): 0
+(16, 2): 184
+(16, 3): 1
+(16, 4): 05/06/96 10:13:04
+(16, 5): URL
+(16, 6):  Computing Resources 
+(16, 7): /TextTest/texttest.dat/software.htm
+(16, 8): 38
+(16, 9): 307
+(17, 0): 0
+(17, 1): 0
+(17, 2): 395
+(17, 3): 1
+(17, 4): 05/06/96 10:12:38
+(17, 5): URL
+(17, 6): Computing Resources Directory
+(17, 7): /TextTest/texttest.dat/crd.htm
+(17, 8): 4
+(17, 9): 302
+(18, 0): 0
+(18, 1): 0
+(18, 2): 823
+(18, 3): 1
+(18, 4): 05/06/96 10:12:48
+(18, 5): URL
+(18, 6): Widget Projects
+(18, 7): /TextTest/texttest.dat/projects.htm
+(18, 8): 18
+(18, 9): 295
+(19, 0): 0
+(19, 1): 0
+(19, 2): 783
+(19, 3): 1
+(19, 4): 05/06/96 10:12:46
+(19, 5): URL
+(19, 6): Widget Co Employee Database
+(19, 7): /TextTest/texttest.dat/people.htm
+(19, 8): 15
+(19, 9): 270
+(20, 0): 0
+(20, 1): 0
+(20, 2): 386
+(20, 3): 1
+(20, 4): 05/06/96 10:12:48
+(20, 5): URL
+(20, 6):  Computing Resources 
+(20, 7): /TextTest/texttest.dat/printer.htm
+(20, 8): 17
+(20, 9): 270
+(21, 0): 0
+(21, 1): 0
+(21, 2): 242
+(21, 3): 1
+(21, 4): 05/06/96 10:13:02
+(21, 5): URL
+(21, 6): Renee Aikens
+(21, 7): /TextTest/texttest.dat/ra.htm
+(21, 8): 36
+(21, 9): 270
+(22, 0): 0
+(22, 1): 0
+(22, 2): 310
+(22, 3): 1
+(22, 4): 05/06/96 10:12:36
+(22, 5): URL
+(22, 6): Baker Project
+(22, 7): /TextTest/texttest.dat/baker.htm
+(22, 8): 2
+(22, 9): 222
+(23, 0): 0
+(23, 1): 0
+(23, 2): 1304
+(23, 3): 1
+(23, 4): 05/06/96 10:12:50
+(23, 5): URL
+(23, 6): Mosaic from Digital Initial Page
+(23, 7): /TextTest/texttest.dat/pw-init.htm
+(23, 8): 22
+(23, 9): 199
+(24, 0): 0
+(24, 1): 0
+(24, 2): 1409
+(24, 3): 1
+(24, 4): 05/06/96 10:13:02
+(24, 5): URL
+(24, 6): Mosaic from Digital Initial Page
+(24, 7): /TextTest/texttest.dat/pwinit.htm
+(24, 8): 35
+(24, 9): 195
+(25, 0): 0
+(25, 1): 0
+(25, 2): 562
+(25, 3): 1
+(25, 4): 05/06/96 10:12:40
+(25, 5): URL
+(25, 6): Lorraine Henniker
+(25, 7): /TextTest/texttest.dat/lt.htm
+(25, 8): 9
+(25, 9): 159
+(26, 0): 0
+(26, 1): 0
+(26, 2): 981
+(26, 3): 1
+(26, 4): 05/06/96 10:13:00
+(26, 5): URL
+(26, 6): The Widget Company Home Page
+(26, 7): /TextTest/texttest.dat/pw-wdgco.htm
+(26, 8): 32
+(26, 9): 140
+Done
+Checking bogus VtextSource::query... NOTE: The following unexpected status is expected:
+
+***Unexpected status in file: texttest.cpp; line: xx ***
+Error #a0006 Message: The field "foo" does not exist in table "index1".
+
+Done
+Checking VtextSource::reIndex... Done
+Checking VtextSource::count... 
+Table has 42 indexed files/documents
+Table has 42 documents in the WAIS index
+Done
+Checking VtextSource::query... 
+Rows: 1
+Cols: 3
+(0, 0): 500
+(0, 1): /TextTest/texttest.dat/orghome.htm
+(0, 2): Org Chart
+Done
+Checking VtextSource::dropTable... Done
+Checking VtextSource::createTextSource... 
+***Unexpected status in file: texttest.cpp; line: xx ***
+Error #a0002 Message: The text source "texttest" already exists in "./testdir/TextTest/_vti_txt/texttest.wti".
+
+Done
+Checking VtextSource::dropTextSource... Done
+Checking VtextSource::dropTextSource... 
+***Unexpected status in file: texttest.cpp; line: xx ***
+Error #a0003 Message: The text source "texttest" does not exist in "./testdir/TextTest/_vti_txt/texttest.wti".
+
+Done
+Checking VtextSource::createTextSource... Done
+Checking VtextSource::createTable... Done
+Checking VtextSource::createTable... 
+***Unexpected status in file: texttest.cpp; line: xx ***
+Error #a0004 Message: The text table "index1" already exists in "./testdir/TextTest/_vti_txt/texttest.wti".
+
+Done
+Checking VtextSource::dropTable... Done
+Checking VtextSource::dropTable... 
+***Unexpected status in file: texttest.cpp; line: xx ***
+Error #a0005 Message: The text table "index1" does not exist in "./testdir/TextTest/_vti_txt/texttest.wti".
+
+Done
+Checking VtextSource::dropTextSource... Done
+Checking VService constructor... Done
+The following error about a non-existant web is expected...
+
+***Unexpected status in file: texttest.cpp; line: xx ***
+Error #50004 Message: There is no web named "/TextErr".
+
 Checking VServer::currentVserver()... Done
 Checking VService constructor... Done
 Checking VtextSource::enumerate... Done
--- ./wel/botform.cpp.allpat	Mon Feb 10 10:11:36 2003
+++ ./wel/botform.cpp	Fri Mar 14 08:01:14 2003
@@ -140,9 +140,10 @@
 
 #ifdef VUNIX
 Vstatus* VbotFormResult::validateEmail(
-    const Vstring & EmailAddress) const
-{
-    Vregexp badChars(VTEXT("[;|></]"));
+    const Vstring & EmailAddress) const{
+
+  // RTR - Removed / from bad character list
+    Vregexp badChars(VTEXT("[;|><]"));
 
     if (EmailAddress.index(badChars) != V_NPOS)
       return VbotMAPIUnknownRecipient(EmailAddress.data());
@@ -551,10 +552,35 @@
         const Vchar *sendmailCmd = service.server().
             lookupConfigParam("SendmailCommand");
 
-        if (sendmailCmd)
+        if (sendmailCmd){
             PipeCommand = sendmailCmd;
-        else
-            goto createIt;
+
+	    // RTR - We need to remove any command line options from command and append a -t
+	    //       Loop until we hit white space and then tack the new string on there.
+	    //
+            BOOL setdasht = TRUE;
+
+            for (size_t ix = 0; ix < PipeCommand.length()-1; ix++) {
+                if ( '-' == PipeCommand[ix] )
+		  if ( 't' == PipeCommand[ix+1] ){
+                        setdasht = FALSE;
+		  }
+
+                if ( '%' == PipeCommand[ix] ){
+		        PipeCommand(ix, 2) = VTEXT("  ");
+			ix += 2;
+                }
+
+            }
+	    
+	    if (setdasht) {
+	        PipeCommand.strip(Vstring::trailing, VCHAR(' '));
+                PipeCommand += VTEXT(" -t");
+	    }
+	}
+
+        goto createIt;
+
     }
     else if (File->index(VTEXT("pipeto:"), 0, Vstring::ignoreCase) != V_NPOS)
     {
@@ -625,25 +651,44 @@
             // FP98 sendmailcommand
             // go through and replace %s with fromAddr and %r with recipient
             // replace %? with ?, so % can be escaped.
+
             const Vchar *fromAddr = Doc->service().server().
                 lookupConfigParam("MailSender");
+
+	    // RTR - We don't really need to strip off the %r and %f because it should already be done... but we
+	    // will leave this in here anyway, can't see what it would hurt.
+
+            BOOL setdasht = TRUE;
             for (size_t ix = 0; ix < PipeCommand.length()-1; ix++)
             {
+                if ( '-' == PipeCommand[ix] )
+		  if ( 't' == PipeCommand[ix+1] ) {
+                        setdasht = FALSE;
+		  }
+
                 if ( '%' == PipeCommand[ix] )
                     switch (PipeCommand[ix+1])
                     {
                     case 'f':
-                        PipeCommand(ix, 2) = fromAddr ? fromAddr : VTEXT("<>");
-                        ix += fromAddr ? Vstrlen(fromAddr) : 2;
+		      // RTR - No command line options allowed
+		        PipeCommand(ix, 2) = VTEXT("  ");
+			ix +=2;
                         break;
                     case 'r':
-                        PipeCommand(ix, 2) = *EmailAddress;
-                        ix += EmailAddress->length();
+		      // RTR - No command line options allowd
+		        PipeCommand(ix, 2) = VTEXT("  ");
+			ix +=2;
                         break;
                     default:
                         PipeCommand(ix, 2) = PipeCommand[ix+1];
                     }
             }
+
+	    if (setdasht) {
+	        PipeCommand.strip(Vstring::trailing, VCHAR(' '));
+                PipeCommand += VTEXT(" -t");
+	    }
+
         }
         goto createIt;
     }
@@ -779,11 +824,14 @@
         }
         if (st)
             return (st);
+
         Out = new VcheckedOstream(OutBase,ResultFileCharSet);
 
         Vbool needTitle = VFALSE; 
         const Vchar *replyTo = NULL;
+	const Vchar *recipient = NULL;
         const Vchar *subject = NULL;
+
         VcharSet headerCharSet = ResultFileCharSet;
         if (!File || !Format)
         {
@@ -858,10 +906,12 @@
             // send out MIME headers
             *Out << "MIME-Version: 1.0" << V_EOL;
             *Out << "Content-Type: Text/";
-            if (isHTML)
+            if (isHTML){
                 *Out << "html";
-            else
+	    }
+            else{
                 *Out << "plain";
+	    }
             *Out << "; charset=" << charSetName << V_EOL;
             *Out << "Content-Transfer-Encoding: " << charSetEncoding << V_EOL;
 
@@ -884,6 +934,10 @@
                 if (subjectFromField)
                     subject = ContentDict->lookupString(subject);
             }
+
+	    // RTR - Always a recipient so we can just do this.
+	    recipient = Dict->lookupString("Email-Address");
+
         }
         else
         {
@@ -891,6 +945,9 @@
             subject = ContentDict->lookupString(VTEXT("PipeToSubject"));
         }
 
+	// RTR - Added recipient block to make recipient part of message body
+        *Out << VTEXT("To: ") << stripWS(recipient) << V_EOL;
+
         if (replyTo)
             *Out << VTEXT("Reply-to: ") << stripWS(replyTo) << V_EOL;
 
@@ -2336,7 +2393,6 @@
 
     return (0);
 }
-
 
 //
 // HISTORY:
--- ./wel/bvector.hpp.allpat	Mon Feb 10 11:03:53 2003
+++ ./wel/bvector.hpp	Thu Feb  6 12:41:26 2003
@@ -25,7 +25,7 @@
 #undef RWGExport
 #define RWGExport _declspec(import)
 
-#endif UTIL_BVECTOR_HXX
+#endif 		// UTIL_BVECTOR_HXX
 
 
 //
--- ./wel/cachemgr.hpp.allpat	Mon Feb 10 11:04:07 2003
+++ ./wel/cachemgr.hpp	Tue Dec  3 15:33:59 2002
@@ -58,12 +58,12 @@
     // We make everybody who uses the cache a friend, and keep our interfaces
     // protected to the masses.  That's because you don't want to use the
     // cache directly; you want to use the cache user.
-    friend Vdocument;
-    friend VimageDocument;
-    friend VmoveOp;
-    friend Vservice;
-    friend VmdictTrans;
-    friend DSPContext;
+    friend class Vdocument;
+    friend class VimageDocument;
+    friend class VmoveOp;
+    friend class Vservice;
+    friend class VmdictTrans;
+    friend class DSPContext;
 
     // Returns VTRUE if it got the metainfo from the cache
     Vbool getDocMetaInfo(
--- ./wel/cernaa.cpp.allpat	Mon Feb 10 11:04:16 2003
+++ ./wel/cernaa.cpp	Fri Jan 24 11:05:12 2003
@@ -66,7 +66,7 @@
 VcernSetup::read(
     const Vchar *filename)
 {
-    Vfstream setupfile;
+    Vifstream setupfile;
     Vstatus *st = NULL;
 
     // remember name of file we're reading, for error reporting
@@ -129,7 +129,7 @@
  */
 Vstatus *
 VcernSetup::parse(
-    Vfstream     &setupfile)
+    Vifstream     &setupfile)
 {
     Vstatus *st = NULL;
     VcernLexer lexer(setupfile);
@@ -312,7 +312,7 @@
  */
 Vstatus *
 VcernSetup::update(
-    Vfstream   & V_UNUSED(oldfile),
+    Vifstream   & V_UNUSED(oldfile),
     size_t     * V_UNUSED(lineno),        // in/out
     Vostream   &newfile)
 {
@@ -522,7 +522,7 @@
 VcernAccess::readACLFile(
     const Vchar *filename)
 {
-    Vfstream aclfile;
+    Vifstream aclfile;
     Vstatus *st = NULL;
 
     // remember name of file we're reading, for error reporting
@@ -554,7 +554,7 @@
  */
 Vstatus *
 VcernAccess::parseACLFile(
-    Vfstream     &aclfile)
+    Vifstream     &aclfile)
 {
     VstringVector args;   // args on one config file line
     Vstatus *st = NULL;
@@ -642,7 +642,7 @@
  */
 Vstatus *
 VcernAccess::updateACLFile(
-    Vfstream   & V_UNUSED(oldfile),
+    Vifstream   & V_UNUSED(oldfile),
     size_t     * V_UNUSED(lineno),
     Vostream   &newfile)
 {
@@ -1437,7 +1437,7 @@
     Vstatus *st = NULL;
     Vstring groupFile;
     VcernGroupList cernGroups;
-    Vfstream in;
+    Vifstream in;
     Vbool fileopen = VFALSE;
     size_t ix;
     Vbool isVermeer;
--- ./wel/cernaa2.cpp.allpat	Mon Feb 10 11:04:29 2003
+++ ./wel/cernaa2.cpp	Fri Jan 24 11:04:45 2003
@@ -26,7 +26,7 @@
 /**********************************************************************
  */
 VcernLexer::VcernLexer(
-    Vfstream &ifile,
+    Vifstream &ifile,
     Vint32    lineno)
     : Ifile(ifile)
     , LexLineno(lineno)
@@ -550,7 +550,7 @@
     const Vchar * filename,
     VcernGroupList &group_list)     // (out)
 {
-    Vfstream ifile;
+    Vifstream ifile;
     Vstatus *st;
 
     if (!filename || !*filename) return (VFALSE);
@@ -585,7 +585,7 @@
  */
 Vstatus *
 parseCernGroupFile(
-    Vfstream &grpfile,
+    Vifstream &grpfile,
     VcernGroupList &group_list) // (out)
 {
     VcernLexer lexer(grpfile);
--- ./wel/cernaa.hpp.allpat	Mon Feb 10 11:04:40 2003
+++ ./wel/cernaa.hpp	Fri Jan 24 11:59:12 2003
@@ -45,7 +45,7 @@
 class VwelExport VcernLexer {
 public:
     VcernLexer(
-        Vfstream &ifile,
+        Vifstream &ifile,
         Vint32 lineno = 1);
     ~VcernLexer();
 
@@ -58,7 +58,7 @@
     Vstring lexBuffer() const;
 
 private:
-    Vfstream &Ifile;
+    Vifstream &Ifile;
     int       LexLineno;
     enum { LexBufferSize = 256 };
     Vchar     LexBuffer[LexBufferSize];
@@ -85,7 +85,7 @@
     ~VcernGrpItem();
 
     Vstatus *parseGrpItem(
-        Vfstream &ifile);
+        Vifstream &ifile);
     Vbool parse_item(
         VcernLexer &lexer);
 
@@ -208,7 +208,8 @@
 
 VwelExport Vstatus *
 parseCernGroupFile(
-    Vfstream &grpfile,
+		   //    Vfstream &grpfile,
+    Vifstream &grpfile,
     VcernGroupList &group_list); // (out)
 
 VwelExport Vstatus *
@@ -230,9 +231,9 @@
     Vstatus *read(
         const Vchar *filename);
     Vstatus *parse(
-        Vfstream     &aclfile);
+        Vifstream     &aclfile);
     Vstatus *update(
-        Vfstream   &oldfile,
+        Vifstream   &oldfile,
         size_t      *lineno,
         Vostream   &newfile);
     Vstatus *write(
@@ -289,9 +290,9 @@
     Vstatus *readACLFile(
         const Vchar *filename);
     Vstatus *parseACLFile(
-        Vfstream     &aclfile);
+        Vifstream     &aclfile);
     Vstatus *updateACLFile(
-        Vfstream   &oldfile,
+        Vifstream   &oldfile,
         size_t      *lineno,
         Vostream   &newfile);
     Vstatus *writeACLFile(
--- ./wel/cernsrvr.hpp.allpat	Mon Feb 10 11:05:02 2003
+++ ./wel/cernsrvr.hpp	Fri Jan 24 11:01:08 2003
@@ -639,7 +639,7 @@
     // Update one config file
     Vstatus *updateConfigFile(
         const Vstring& fileName,
-        Vfstream& infile,
+        Vifstream& infile,
         Vostream& outfile,
         const VcernFileType fileType);
 
--- ./wel/text.cpp.allpat	Fri Feb 21 07:40:36 2003
+++ ./wel/text.cpp	Mon Feb 10 07:59:37 2003
@@ -554,7 +554,11 @@
     const Vservice& service,
     Vpath& textDir)
 {
+#ifndef ALPHAOSF
     delete textDir.stat();
+#else
+    delete textDir.localstat();
+#endif
     if (!(textDir.exists() && textDir.isDir())
         || service.server().httpServer()->hasTripoli())
         return (VtextDirDoesntExist(textDir.name()));
@@ -567,7 +571,11 @@
     const Vstring& textSourceName,
     Vbool          mustExist)
 {
+#ifndef ALPHAOSF
     delete textSourcePath.stat();
+#else
+    delete textSourcePath.localstat();
+#endif
     Vbool exists = textSourcePath.exists() && textSourcePath.isDir();
 
     if (exists && !mustExist)
--- ./wel/cernsrvr.cpp.allpat	Mon Feb 10 11:05:08 2003
+++ ./wel/cernsrvr.cpp	Tue Jan 28 07:55:35 2003
@@ -759,7 +759,7 @@
     if(!LockConfig.locked())
         return VconfigNotLockedError(ConfigFile);
 
-    Vfstream &inConfig = LockConfig.inFile();
+    Vifstream &inConfig = LockConfig.inFile();
     Vostream &outConfig = LockConfig.outFile();
 
     outConfig.setOutputConversion(VioCvtToLCP);
@@ -805,7 +805,7 @@
 // Move fileName.tmp into fileName
 Vstatus *VcernServer::updateConfigFile(
     const Vstring& fileName,
-    Vfstream& infile,
+    Vifstream& infile,
     Vostream& outfile,
     const VcernFileType fileType)
 {
--- ./wel/cssdoc.hpp.allpat	Mon Feb 10 11:05:33 2003
+++ ./wel/cssdoc.hpp	Fri Jan 24 12:00:42 2003
@@ -37,7 +37,7 @@
         VdocHint  docType = VDHUnknown,
         Vdocument* includingDocument = 0);
 
-	Vstatus* readDoc(Vfstream& in, Vstring& content);
+	Vstatus* readDoc(Vifstream& in, Vstring& content);
 	Vstatus* writeDoc(Vostream& out, Vstring& content);
 };
 
--- ./wel/doc.hpp.allpat	Mon Feb 10 11:05:40 2003
+++ ./wel/doc.hpp	Thu Feb  6 12:33:47 2003
@@ -1258,8 +1258,8 @@
     Vstring getEffectiveDocBase();
 
     // VbackLinks and VmoveOp needs access to this.
-    friend VbackLinks;
-    friend VmoveOp;
+    friend class VbackLinks;
+    friend class VmoveOp;
     const VstringVector& getCachedBackLinkInfo();
 
     // Add urls to list of backlinks
--- ./wel/doccss.cpp.allpat	Mon Feb 10 11:05:52 2003
+++ ./wel/doccss.cpp	Fri Jan 24 11:05:42 2003
@@ -271,7 +271,7 @@
 
 	Vstring content;
 
-	Vfstream	in;
+	Vifstream	in;
 
 	if ((st = in.open(ContentFile, "r")))
 		return (st);
@@ -342,7 +342,7 @@
 }
 
 
-Vstatus* VcssDocument::readDoc(Vfstream& in, Vstring& content)
+Vstatus* VcssDocument::readDoc(Vifstream& in, Vstring& content)
 {
 	Vstring		line;
 	Vstring		eol(V_EOL);
--- ./wel/fpsrvadm.cpp.allpat	Mon Feb 10 11:06:10 2003
+++ ./wel/fpsrvadm.cpp	Tue Dec  3 15:33:59 2002
@@ -59,8 +59,11 @@
 
 // global for passing port to signal handler
 Vstring sigPort;
+#ifndef SGI
 void (V_CDECL *sigPrev)(int) = 0;
-
+#else
+void (V_CDECL *sigPrev)(...) = 0;
+#endif
 static FrameworkUnix *SigThis = NULL;
 
 FrameworkUnix::FrameworkUnix()
@@ -339,7 +342,11 @@
     SigThis = this;
     sigPort = Port;
     sigPrev = signal(SIGINT, sigHandler);
+#ifndef SGI
     if(sigPrev == (void(V_CDECL *)(int))SIG_ERR)
+#else
+    if(sigPrev == (void(V_CDECL *)(...))SIG_ERR)
+#endif
     {
         VDIAG(0, 0, VTEXT("Cannot set signal handler for ctrl-C\n"));
         exit(1);
@@ -1003,7 +1010,11 @@
     return (0);
 }
 
+#ifndef SGI
 void FrameworkUnix::sigHandler(int /* sig */)
+#else
+void FrameworkUnix::sigHandler(... /* sig */)
+#endif
 {
     SigThis->cnfCleanup(sigPort);
     exit(2);
--- ./wel/fpsrvadm.hpp.allpat	Mon Feb 10 11:06:21 2003
+++ ./wel/fpsrvadm.hpp	Mon Apr  7 12:59:02 2003
@@ -58,8 +58,11 @@
     Vstatus* readChownInfo();
 #endif // VUNIX
 
+#ifndef SGI
     static void V_CDECL sigHandler(int sig);
-    
+#else
+    static void V_CDECL sigHandler(...);
+#endif    
     virtual void doSignal();
 
     virtual void setUpSignal();
--- ./wel/fpsrvfrm.cpp.allpat	Mon Feb 10 11:06:33 2003
+++ ./wel/fpsrvfrm.cpp	Fri Mar 14 07:35:48 2003
@@ -2554,7 +2554,11 @@
     diagInfo("Original Version: %s\n", serverVersion.data());
 
     Vversion vServerVersion(serverVersion);
+#ifndef FREEBSD
     if (!vServerVersion.isInstallableOn())
+#else
+    if (!vServerVersion.isInstallableOn(vServerVersion))
+#endif
     {
         if (vServerVersion > VVERSION_CURRENT)
             return VsrvadmClientTooOld();
@@ -2578,7 +2582,11 @@
     diagInfo("Version: %s\n", serverVersion.data());
 
     Vversion vServerVersion(serverVersion);
+#ifndef FREEBSD
     if (!vServerVersion.isInstallableOn())
+#else
+    if (!vServerVersion.isInstallableOn(vServerVersion))
+#endif
     {
         if (vServerVersion > VVERSION_CURRENT)
             return VsrvadmClientTooOld();
@@ -2602,7 +2610,11 @@
     diagInfo("Version: %s\n", serverVersion.data());
 
     Vversion vServerVersion(serverVersion);
+#ifndef FREEBSD
     if (!vServerVersion.isFeatureCompatible())
+#else
+    if (!vServerVersion.isFeatureCompatible(vServerVersion))
+#endif
     {
         if (vServerVersion > VVERSION_CURRENT)
             return VsrvadmClientTooOld();
--- ./wel/getlinks.cpp.allpat	Mon Feb 10 11:06:45 2003
+++ ./wel/getlinks.cpp	Thu Jan 23 11:43:53 2003
@@ -722,7 +722,7 @@
     Vframework::currentFramework().sleep(2);
 
     // reverse the sense of this option each time through this test
-    static bIncludeParent = VFALSE;
+    static Vbool bIncludeParent = VFALSE;
     bIncludeParent = !bIncludeParent;
 
     // traverse from root, recursing
--- ./wel/httpsrvr.cpp.allpat	Mon Feb 10 11:06:59 2003
+++ ./wel/httpsrvr.cpp	Fri Feb 21 08:02:28 2003
@@ -39,6 +39,7 @@
 #ifdef V_NETSCAPE
 #include "wel/ntstsrvr.hpp"     /* for NTST server config info */
 #endif /* V_NETSCAPE */
+#include <unistd.h>
 #endif /* VUNIX */
 #include "wel/httpsrvr.hpp"
 #include "util/dll.hpp"
@@ -172,7 +173,7 @@
     // enter internal values
 #ifdef VWIN32
     if (!prettyList)
-#endif VWIN32
+#endif 		// VWIN32
     {
         // unit tests require the obsolete cern server
         if(Vframework::currentFramework().testProgram())
--- ./wel/makefile.allpat	Mon Feb 10 11:07:07 2003
+++ ./wel/makefile	Thu Feb  6 14:33:43 2003
@@ -359,6 +359,11 @@
 ifneq "$(PLATFORM)" "sco5"
 ifneq "$(PLATFORM)" "uware-7"
 ifneq "$(PLATFORM)" "linux"
+ifneq "$(PLATFORM)" "solaris"
+ifneq "$(PLATFORM)" "solarisx86"
+ifneq "$(PLATFORM)" "sgi"
+ifneq "$(PLATFORM)" "hp700"
+ifneq "$(PLATFORM)" "alpha"
 #$(BINDIR)/rpctest$O: $(BINDIR)/rpctest.cc
 #	g++ $(CF_OPT) $(CF_OTHER) $(CF_WARN) -c $< -o $@
 $(BINDIR)/bvector$O: $(BINDIR)/bvector.cc
@@ -374,11 +379,16 @@
 endif
 endif
 endif
+endif
+endif
+endif
+endif
+endif
 ifeq "$(PLATFORM)" "alpha"
 $(BINDIR)/fpsrvfrm$O: fpsrvfrm.cpp
-	g++ $(CXXFLAGS) -O0 $(CF_WARN) -c $< -o $@
+	$(CXX) $(CXXFLAGS) -O0 $(CF_WARN) -c $< -o $@
 $(BINDIR)/request$O: request.cpp
-	g++ $(CXXFLAGS) -O0 $(CF_WARN) -c $< -o $@
+	$(CXX) $(CXXFLAGS) -O0 $(CF_WARN) -c $< -o $@
 endif
 endif
 
--- ./wel/ncsaaa.cpp.allpat	Mon Feb 10 11:07:22 2003
+++ ./wel/ncsaaa.cpp	Fri Jan 24 12:30:15 2003
@@ -139,7 +139,7 @@
  */
 Vstatus *
 parseGroupFile(
-    Vfstream    &grpfile,
+    Vifstream    &grpfile,
     VaaGroupList &grplist,      // out
     Vbool        &isVermeer)    // out - TRUE if file has Vermeer comment
 {
@@ -251,7 +251,7 @@
  */
 Vstatus *
 parsePasswordFile(
-    Vfstream   &pwdfile,
+    Vifstream   &pwdfile,
     VaaUserList &users,         // out (from this function)
     Vbool       &isVermeer)     // out - TRUE if file has Vermeer comment
 {
@@ -520,7 +520,7 @@
 Vstatus *
 VncsaLimit::parseSection(
     Vstring line,               // first line, w/ "<Limit ...>"
-    Vfstream &aclfile)
+    Vifstream &aclfile)
 {
     Vstatus *st = NULL;
     VstringVector args;
@@ -771,7 +771,7 @@
 VncsaAccess::readACLFile(
     const Vchar *filename)
 {
-    Vfstream aclfile;
+    Vifstream aclfile;
     Vstatus *st = NULL;
 
     // remember name of file we're reading, for error reporting
@@ -781,7 +781,7 @@
     if (st = aclfile.open( filename, "r" ))
         goto cleanup;
 
-    aclfile.setOutputConversion(VioCvtToLCP);
+    //    aclfile.setOutputConversion(VioCvtToLCP);
 
     if (st = parseACLFile( aclfile ))
         goto cleanup;
@@ -813,7 +813,7 @@
  */
 Vstatus *
 VncsaAccess::parseACLFile(
-    Vfstream     &aclfile)
+    Vifstream     &aclfile)
 {
     size_t limitix = 0;
     VstringVector args;   // args on one config file line
@@ -938,7 +938,7 @@
  */
 Vstatus *
 VncsaAccess::updateACLFile(
-    Vfstream   &oldfile,
+    Vifstream   &oldfile,
     size_t      *lineno,        // in/out
     Vostream   &newfile)
 {
@@ -1828,7 +1828,7 @@
     Vstring passwordFile;
     Vstring   aclRealm;
     Vbool     isVermeer;
-    Vfstream  in;
+    Vifstream  in;
     Vbool     fileopen = VFALSE;
     Vbool     locationOk;
 
@@ -2175,7 +2175,7 @@
     Vstring   aclRealm;
     Vbool     isVermeer;
     Vbool     locationOk;
-    Vfstream  in;
+    Vifstream  in;
     Vbool     fileopen = VFALSE;
 
     editable = VFALSE;
--- ./wel/ncsaaa.hpp.allpat	Mon Feb 10 11:07:36 2003
+++ ./wel/ncsaaa.hpp	Fri Jan 24 12:03:06 2003
@@ -34,7 +34,7 @@
     VncsaLimit();
     Vstatus *parseSection(
         Vstring line,           // first line, w/ "<Limit ...>"
-        Vfstream &aclfile);
+        Vifstream &aclfile);
     Vstatus *writeSection(
         Vostream &aclfile);
     void Reset();
@@ -92,9 +92,9 @@
     Vstatus *readACLFile(
         const Vchar *filename);
     Vstatus *parseACLFile(
-        Vfstream     &aclfile);
+        Vifstream     &aclfile);
     Vstatus *updateACLFile(
-        Vfstream   &oldfile,
+        Vifstream   &oldfile,
         size_t      *lineno,
         Vostream   &newfile);
     Vstatus *writeACLFile(
@@ -151,7 +151,7 @@
  */
 VwelExport Vstatus *
 parseGroupFile(
-    Vfstream &grpfile,
+    Vifstream &grpfile,
     Vvector(VaaGroup) &grplist, // out
     Vbool &isVermeer);          // out - TRUE if file contains Vermeer comment
 VwelExport Vstatus *
@@ -160,7 +160,7 @@
     Vvector(VaaGroup) &grplist);// in
 VwelExport Vstatus *
 parsePasswordFile(
-    Vfstream     &pwdfile,
+    Vifstream     &pwdfile,
     Vvector(VaaUser) &users,    // out (from this function)
     Vbool &isVermeer);          // out - TRUE if file contains Vermeer comment
 VwelExport Vstatus *
--- ./wel/ncsasrvr.cpp.allpat	Mon Feb 10 11:07:51 2003
+++ ./wel/ncsasrvr.cpp	Fri Jan 24 11:06:25 2003
@@ -1192,7 +1192,7 @@
     if (err = LockResource.beginTextUpdate( resourceFile, VTRUE, VTRUE ))
         return err;
 
-    Vfstream &inResource = LockResource.inFile();
+    Vifstream &inResource = LockResource.inFile();
     Vostream &outResource = LockResource.outFile();
 
     outResource.setOutputConversion(VioCvtToLCP);
@@ -1253,7 +1253,7 @@
 // Move fileName.tmp into fileName
 Vstatus *VncsaHostConfig::updateConfigFile(
     const Vstring& fileName,
-    Vfstream& infile,
+    Vifstream& infile,
     Vostream& outfile,
     const VncsaFileType fileType,
     VncsaHostConfigList* vhosts)
@@ -2772,7 +2772,7 @@
         return VconfigNotLockedError(ConfigFile);
 
     // The main config file
-    Vfstream &inConfig = LockConfig.inFile();
+    Vifstream &inConfig = LockConfig.inFile();
     Vostream &outConfig = LockConfig.outFile();
 
     outConfig.setOutputConversion(VioCvtToLCP);
--- ./wel/ncsasrvr.hpp.allpat	Mon Feb 10 11:07:58 2003
+++ ./wel/ncsasrvr.hpp	Fri Jan 24 12:02:02 2003
@@ -208,7 +208,7 @@
     // Update one config file 
     Vstatus *updateConfigFile(
         const Vstring& fileName,
-        Vfstream& infile,
+        Vifstream& infile,
         Vostream& outfile,
         const VncsaFileType fileType,
         VncsaHostConfigList* vhosts);
@@ -1005,7 +1005,7 @@
     // Update one config file
     Vstatus *updateConfigFile(
         const Vstring& fileName,
-        Vfstream& infile,
+        Vifstream& infile,
         Vostream& outfile,
         const VncsaFileType fileType);
     
--- ./wel/ntstaa.cpp.allpat	Mon Feb 10 11:08:13 2003
+++ ./wel/ntstaa.cpp	Fri Jan 24 11:09:57 2003
@@ -76,7 +76,7 @@
  */
 static Vstatus *
 parseGroupFile(
-    Vfstream &grpfile,
+    Vifstream &grpfile,
     VstringVector &users,       // out
     Vbool &isVermeer);          // out - TRUE if file contains Vermeer comment
 
@@ -173,7 +173,7 @@
  */
 static Vstatus *
 parseGroupFile(
-    Vfstream    &pwdfile,
+    Vifstream    &pwdfile,
     VstringVector &users,       // out
     Vbool        &isVermeer)    // out - TRUE if file has Vermeer comment
 {
@@ -522,7 +522,7 @@
 Vstatus *
 VntstLimit::parseSection(
     Vstring line,               // first line, w/ "<Limit ...>"
-    Vfstream &aclfile)
+    Vifstream &aclfile)
 {
     Vstatus *st = 0;
     VstringVector args;
@@ -632,7 +632,7 @@
 Vstatus *
 VntstLimit::writeSection(
     Vostream  &aclfile,
-    Vfstream  &oldfile,
+    Vifstream  &oldfile,
     Vbool updating)
 {
     Vstatus *st = 0;
@@ -869,7 +869,7 @@
 VntstAccess::readACLFile(
     const Vchar *szFilename)
 {
-    Vfstream aclfile;
+    Vifstream aclfile;
     Vstatus *st = 0;
     Vstring filename = szFilename;
 
@@ -901,7 +901,7 @@
  */
 Vstatus *
 VntstAccess::parseACLFile(
-    Vfstream     &aclfile)
+    Vifstream     &aclfile)
 {
     Vstring line;
     Vstatus *st = 0;
@@ -941,7 +941,7 @@
 Vstatus *
 VntstAccess::writeLimitSections(
     Vostream    &newfile,
-    Vfstream    &oldfile,
+    Vifstream    &oldfile,
     Vbool       updating)
 {
     Vstatus *st = 0;
@@ -973,7 +973,7 @@
  */
 Vstatus *
 VntstAccess::updateACLFile(
-    Vfstream   &oldfile,
+    Vifstream   &oldfile,
     size_t      *lineno,        // in/out
     Vostream   &newfile)
 {
@@ -1053,7 +1053,7 @@
     Vstatus *st = 0;
     Vofstream aclFile;
     Vbool fileOpen = VFALSE;
-    Vfstream dummyStream;
+    Vifstream dummyStream;
     Vstring filename = szFilename;
 
     if (st = aclFile.open( filename, "w" ))
@@ -1694,7 +1694,7 @@
     Vstring passwordFile;
     Vstring   aclRealm;
     Vbool     isVermeer;
-    Vfstream  in;
+    Vifstream  in;
     Vbool     fileopen = VFALSE;
     Vbool     locationOk;
 
@@ -1982,7 +1982,7 @@
     Vstring   aclRealm;
     Vbool     isVermeer;
     Vbool     locationOk;
-    Vfstream  in;
+    Vifstream  in;
     Vbool     fileopen = VFALSE;
 
     editable = VFALSE;
--- ./wel/ntstaa.hpp.allpat	Mon Feb 10 11:08:21 2003
+++ ./wel/ntstaa.hpp	Fri Jan 24 12:05:45 2003
@@ -108,10 +108,10 @@
     VntstLimit();
     Vstatus *parseSection(
         Vstring line,           // first line, w/ "<File ...>"
-        Vfstream &aclfile);
+        Vifstream &aclfile);
     Vstatus *writeSection(
         Vostream &aclfile,
-        Vfstream  &oldfile,
+        Vifstream  &oldfile,
         Vbool     updating = VTRUE); // VTRUE if updating, else VFALSE
 
     void Reset();
@@ -229,9 +229,9 @@
     Vstatus *readACLFile(
         const Vchar *filename);
     Vstatus *parseACLFile(
-        Vfstream     &aclfile);
+        Vifstream     &aclfile);
     Vstatus *updateACLFile(
-        Vfstream   &oldfile,
+        Vifstream   &oldfile,
         size_t      *lineno,
         Vostream   &newfile);
     Vstatus *writeACLFile(
@@ -278,7 +278,7 @@
 private:
     Vstatus *writeLimitSections(
         Vostream    &newfile,
-        Vfstream    &oldfile,
+        Vifstream    &oldfile,
         Vbool       updating = VTRUE);
 
     Vbool   IsVermeer;      // TRUE if file was created by us (we check for
--- ./wel/ntstsrvr.cpp.allpat	Mon Feb 10 11:08:33 2003
+++ ./wel/ntstsrvr.cpp	Fri Jan 24 11:09:11 2003
@@ -2405,7 +2405,7 @@
             return VconfigNotLockedError(ConfigFile);
 
         // The main config file
-        Vfstream &inConfig = LockConfig.inFile();
+        Vifstream &inConfig = LockConfig.inFile();
         Vostream &outConfig = LockConfig.outFile();
 
         outConfig.setOutputConversion(VioCvtToLCP);
@@ -2423,7 +2423,7 @@
         if (err=lockObject.beginTextUpdate( objectFile, VTRUE, VTRUE ))
             return err;
 
-        Vfstream &inObject = lockObject.inFile();
+        Vifstream &inObject = lockObject.inFile();
         Vostream &outObject = lockObject.outFile();
 
         outObject.setOutputConversion(VioCvtToLCP);
@@ -2524,7 +2524,7 @@
 // Move fileName.tmp into fileName
 Vstatus *VntstServer::updateConfigFile(
     const Vstring& fileName,
-    Vfstream& infile,
+    Vifstream& infile,
     Vostream& outfile)
 {
     Vstatus *err;
@@ -2688,7 +2688,7 @@
 // Move fileName.tmp into fileName
 Vstatus *VntstServer::updateObjectFile(
     const Vstring& fileName,
-    Vfstream& infile,
+    Vifstream& infile,
     Vostream& outfile)
 {
     Vstatus *err;
--- ./wel/ntstsrvr.hpp.allpat	Mon Feb 10 11:08:39 2003
+++ ./wel/ntstsrvr.hpp	Fri Jan 24 12:04:50 2003
@@ -1000,13 +1000,13 @@
     // Update one config file
     Vstatus *updateConfigFile(
         const Vstring& fileName,
-        Vfstream& infile,
+        Vifstream& infile,
         Vostream& outfile);
 
     // Update one object file
     Vstatus *updateObjectFile(
         const Vstring& fileName,
-        Vfstream& infile,
+        Vifstream& infile,
         Vostream& outfile);
 
     // Write out values at end of config file, that have not been written yet
--- ./wel/offdoc.cpp.allpat	Mon Feb 10 11:08:48 2003
+++ ./wel/offdoc.cpp	Tue Dec  3 15:34:00 2002
@@ -41,12 +41,12 @@
 GUID FormatID_UserDefinedProperties = {
     0xd5cdd505L,0x2e9c,0x101b,{0x93,0x97,0x08,0x00,0x2b,0x2c,0xf9,0xae} };
 
-const VPID_CODEPAGE      = 0x00000001;
-const VPID_TITLE         = 0x00000002;
+const int VPID_CODEPAGE      = 0x00000001;
+const int VPID_TITLE         = 0x00000002;
 
-const VPID_CATEGORIES    = 0x00000001; // NOTE: these numbers aren't the real
-const VPID_ASSIGNEDTO    = 0x00000002; // storage PIDs for these properties.
-const VPID_APPROVALLEVEL = 0x00000003; // They're just for interal tracking.
+const int VPID_CATEGORIES    = 0x00000001; // NOTE: these numbers aren't the real
+const int VPID_ASSIGNEDTO    = 0x00000002; // storage PIDs for these properties.
+const int VPID_APPROVALLEVEL = 0x00000003; // They're just for interal tracking.
 
 #if defined(VWIN32) && !defined(_MAC)
 Vwchar WSPID_CATEGORIES[]    = L"Categories";
@@ -59,9 +59,9 @@
 #endif
 
 // Link format Version 1
-const VPID_HYPERLINKS = 0x00000015;
-const VPID_HYPERLINKS_CHANGED = 0x00000016;
-const VPID_LINKBASE = 0x00000014;
+const int VPID_HYPERLINKS = 0x00000015;
+const int VPID_HYPERLINKS_CHANGED = 0x00000016;
+const int VPID_LINKBASE = 0x00000014;
 
 // Link format Version 2
 const char *SPID_HYPERLINKS = "_PID_HLINKS";
--- ./wel/portconf.hpp.allpat	Mon Feb 10 11:09:09 2003
+++ ./wel/portconf.hpp	Tue Apr  8 10:16:34 2003
@@ -45,6 +45,10 @@
 // Do we hash the per virtual server cnf file names, and if so how
 // many characters do we use?
 #define VConfigFileHashDepth         VTEXT("ConfigFileHashDepth")
+#if defined  SP_WHISTLER || defined VUNIX
+// MaxAnonContentLength defines a hard limit for all anonymous requests
+#define VMaxAnonContentLength VTEXT("MaxAnonContentLength")
+#endif // SP_WHISTLER
 
 class VutilExport VupdateLock;
 class VportConfMgr;
@@ -251,7 +255,7 @@
 #endif
 
 private:
-    friend VportConf;
+    friend class VportConf;
 
     VstringVector    PortList;
     Vbool            PortListInit;
--- ./wel/pwdfile.cpp.allpat	Mon Feb 10 11:09:22 2003
+++ ./wel/pwdfile.cpp	Fri Jan 24 12:03:39 2003
@@ -57,7 +57,7 @@
     Vvector(VaaUser) &users)    // (out)
 {
     Vstatus *st = NULL;
-    Vfstream  in;
+    Vifstream  in;
     VaaUser user;
     Vbool eof = VFALSE;
 
@@ -310,7 +310,7 @@
  */
 Vstatus *
 VcernPwdFile::readNextRecord(
-    Vfstream &ifile,
+    Vifstream &ifile,
     VaaUser &user,      // (out)
     Vbool &eof)         // (out)
 {
@@ -532,7 +532,7 @@
  */
 Vstatus *
 VncsaPwdFile::readNextRecord(
-    Vfstream &ifile,
+    Vifstream &ifile,
     VaaUser &user,      // (out)
     Vbool &eof)         // (out)
 {
@@ -695,7 +695,7 @@
  */
 Vstatus *
 VvermeerPwdFile::readNextRecord(
-    Vfstream &ifile,
+    Vifstream &ifile,
     VaaUser &user,      // (out)
     Vbool &eof)         // (out)
 {
--- ./wel/pwdfile.hpp.allpat	Mon Feb 10 11:09:32 2003
+++ ./wel/pwdfile.hpp	Fri Jan 24 11:08:48 2003
@@ -65,7 +65,7 @@
     virtual Vbool openBinary();
 
     virtual Vstatus *readNextRecord(
-        Vfstream &ifile,
+        Vifstream &ifile,
         VaaUser &user,      // (out)
         Vbool &eof) = 0;    // (out)
     virtual Vstatus *writeNextRecord(
@@ -107,7 +107,7 @@
 
 protected:
     virtual Vstatus *readNextRecord(
-        Vfstream &ifile,
+        Vifstream &ifile,
         VaaUser &user,      // (out)
         Vbool &eof);        // (out)
     virtual Vstatus *writeNextRecord(
@@ -144,7 +144,7 @@
 
 protected:
     virtual Vstatus *readNextRecord(
-        Vfstream &ifile,
+        Vifstream &ifile,
         VaaUser &user,      // (out)
         Vbool &eof);        // (out)
     virtual Vstatus *writeNextRecord(
@@ -187,7 +187,7 @@
 protected:
     virtual Vbool openBinary();
     virtual Vstatus *readNextRecord(
-        Vfstream &ifile,
+        Vifstream &ifile,
         VaaUser &user,      // (out)
         Vbool &eof);        // (out)
     virtual Vstatus *writeNextRecord(
--- ./wel/serviccb.hpp.allpat	Mon Feb 10 11:09:44 2003
+++ ./wel/serviccb.hpp	Tue Dec  3 15:34:00 2002
@@ -13,6 +13,8 @@
 
 #include "util/path.hpp"
 #include "util/url.hpp"
+#include "util/urldir.hpp"
+#include "wel/service.hpp"
 
 class VmetaDict;
 
--- ./wel/strucops.hpp.allpat	Mon Feb 10 11:09:55 2003
+++ ./wel/strucops.hpp	Tue Dec  3 15:34:00 2002
@@ -99,7 +99,7 @@
     Vint32 NavBits( Vservice *pService );
 
 protected:
-    friend VstructureStore;
+    friend class VstructureStore;
 	VStructureElement& getElement() {return m_element;}
 	Vvector(pVstructureStoreNode)& getSiblings() {return parent()->m_children;}
 	Vvector(pVstructureStoreNode)& getChildren() {return m_children;}
--- ./wel/bottrip.cpp.allpat	Tue Feb 18 17:08:48 2003
+++ ./wel/bottrip.cpp	Tue Jan 28 08:54:18 2003
@@ -461,7 +461,7 @@
 
 
         { // Print out file
-        Vfstream &in = lock.inFile();
+        Vifstream &in = lock.inFile();
         Vostream &out = lock.outFile();
 
         Vstatus* st = 0;
--- ./wel/svcmgr.hpp.allpat	Fri Feb 21 07:57:51 2003
+++ ./wel/svcmgr.hpp	Fri Feb 21 07:58:42 2003
@@ -50,7 +50,7 @@
 };
 
 
-#endif WEL_SVCMGR_HPP
+#endif 		// WEL_SVCMGR_HPP
 
 //
 // HISTORY:
--- ./wel/vdoc.hpp.allpat	Fri Feb 21 07:59:09 2003
+++ ./wel/vdoc.hpp	Fri Feb 21 07:59:28 2003
@@ -23,4 +23,4 @@
 #undef RWGExport
 #define RWGExport _declspec(import)
 
-#endif WEL_VDOC_HXX
+#endif 		// WEL_VDOC_HXX
--- ./wel/doctrans.hpp.allpat	Fri Feb 21 07:59:49 2003
+++ ./wel/doctrans.hpp	Fri Feb 21 08:00:07 2003
@@ -57,7 +57,7 @@
 };
 
 
-#endif WEL_DOCTRANS_HPP
+#endif 	// WEL_DOCTRANS_HPP
 
 //
 // HISTORY:
--- ./wel/overlays.cpp.allpat	Fri Feb 21 08:03:02 2003
+++ ./wel/overlays.cpp	Fri Feb 21 08:03:12 2003
@@ -183,4 +183,4 @@
         delete metaInfos[C - 1];
     delete pFontDict;
     return st;
-}
\ No newline at end of file
+}
--- ./wel/server.cpp.allpat	Fri Feb 21 09:20:51 2003
+++ ./wel/server.cpp	Tue Apr  8 07:50:22 2003
@@ -2456,7 +2456,11 @@
     Vurl scriptUrl( serviceUrl );
     for(tries = 0;; tries++)
     {
+#ifndef ALPHAOSF
         err = path.stat();
+#else
+        err = path.localstat();
+#endif
         if(!err)
             break;
 
@@ -2516,7 +2520,11 @@
         {
             Vpath pathWelcome(path.asString(), welcome[i]);
 
+#ifndef ALPHAOSF
             if(err = pathWelcome.stat())
+#else
+            if(err = pathWelcome.localstat())
+#endif
             {
                 // error from stat on this welcome name, try next one
                 delete err;
@@ -2577,7 +2585,8 @@
 
     // reject extremely long URLs to prevent DoS attacks
     // See Office9:267179
-    if (urlArg.length() > 2 * INTERNET_MAX_URL_LENGTH)
+    //    if (urlArg.length() > 2 * INTERNET_MAX_URL_LENGTH)
+    if (urlArg.length() + baseUrl.length() > 2 * INTERNET_MAX_URL_LENGTH)
         return VFALSE;
 
     // we still want to reject Urls with too many slashes
@@ -2589,6 +2598,11 @@
         if (urlArg.length() > nMaxSlashes)
         {
             const Vchar* s = urlArg.data();
+            while (*s)
+                if (*s++ == '/' && ++nFoundSlashes > nMaxSlashes)
+                    return VFALSE;
+
+            s = baseUrl.data();		// apr 03 update
             while (*s)
                 if (*s++ == '/' && ++nFoundSlashes > nMaxSlashes)
                     return VFALSE;
--- ./wel/rpcdisp.cpp.allpat	Tue Dec  3 15:34:00 2002
+++ ./wel/rpcdisp.cpp	Mon Apr  7 11:54:46 2003
@@ -82,7 +82,6 @@
 #include "wel/thememgr.hpp"             /* for VthemeManager */
 #include "util/db.hpp"                  /* Declarations for database info */
 #include "wel/htmtable.hpp"
-
 #ifdef FPHOOK        /***** Author: rogerv @@@*****/
 #include "wel/waghksp.hpp"
 #include <fstream.h>
@@ -2888,7 +2887,7 @@
     Vdocument* doc = 0;
     VmetaDict* metaInfo = 0;            // GNU's on -O2 drugs: shut him up
     const Vstring* fullDocPath = 0;     // GNU's on -O2 drugs: shut him up
-    Vifstream  docFile;
+    Vfstream  docFile;
     Vbool      bFileOpen = VFALSE;
     Vstring    docPath;
     Vbool      oldSmartHTML = VFALSE;
@@ -4950,7 +4949,6 @@
         { VTEXT("timeout"), 4 },
         { VTEXT("validateWelcomeNames"),  5 },
     };
-
     STD_GET
         GET_STD_VARS;
         case 2:
@@ -4964,6 +4962,9 @@
             break;
         case 4:
             argin >> timeout;
+#ifdef DUNIX
+	    if(timeout == INT_MAX) timeout = -1;
+#endif
             break;
         case 5:
             bValidateWelcomeNames = RcvBool( argin );
--- ./wel/rpctestw.cpp.allpat	Mon Apr  7 12:03:31 2003
+++ ./wel/rpctestw.cpp	Mon Apr  7 12:56:21 2003
@@ -192,7 +192,12 @@
     if( server.httpServer()->isSingleVtiBin() &&
         !singleVtiBinSecurityCheck(&server, lookupContext("SCRIPT_NAME")) )
     {
-        sendAccessDeniedHeader(*outStream());
+       if (server.isSSLRequiredForAuthoring() && !server.isSSLRequest())
+         {
+             st = Verror(V_AUTH_SSL_REQUIRED_FOR_AUTHORING, 0);
+             return st;
+         }
+          sendAccessDeniedHeader(*outStream());
         return 0;
     }
 #endif
--- ./wel/request.cpp.allpat	Tue Apr  8 15:35:33 2003
+++ ./wel/request.cpp	Tue Apr  8 16:52:17 2003
@@ -104,7 +104,6 @@
     Vlock_type serviceLock)
 {
     unlock();
-
     Vstatus *st = NULL;
     Service = s;
     ServiceLock = serviceLock;
@@ -636,13 +635,22 @@
 // HTTP_USER_AGENT=Mozilla/1.0N (Windows)
 // HTTP_REFERER=http://www.vermeer.com:8088/vti/form1.htm
 
-
 // Read contentLength bytes of URL encoded content from standard input.
 // Add name/value pairs to dictionary.
 void
 Vrequest::readCGIParams()
 {
+    readCGIParamsEx();
+    return;
+}
+
+// Office 9 # 267809 (port from Office 10 # 347718)
+// Limit anonymous user to 1MG input
+Vbool
+Vrequest::readCGIParamsEx()
+{
     const Vchar *value;
+    
     if ((value = lookupEnv(VTEXT("REQUEST_METHOD"))))
     {
         if (!Vstricmp(value, VTEXT("POST")))
@@ -659,7 +667,42 @@
 
     // Check for out-of-band content length and exit
     if ((contentLength + 1) <= 1)
-        return;
+        return VTRUE;
+
+    // Office 9 # 267809 (port from Office 10 # 347718)
+    // Set a hard limit here for anonymous requests.
+    // This fixes a whole series of DOS attacks.
+    const Vchar *szRemoteUser = lookupEnv(VTEXT("REMOTE_USER"));
+    if (!szRemoteUser || !szRemoteUser[0])
+    {
+        // set a factory default of 1 MB
+        Vint32 maxAnonContentLength = 1024 * 1024;
+
+        if (Vframework::currentFrameworkExists() &&
+           !Vframework::currentFramework().testProgram())
+        {
+            const Vchar *szMaxAnonContentLength = 
+                Server.lookupConfigParam(VMaxAnonContentLength);
+            Vint32 newLimit;
+            // overwrite the factory default to a custom size based
+            // on a metaproperty, if it exists
+            if(szMaxAnonContentLength && (newLimit=Vatoi(szMaxAnonContentLength))>0)
+                maxAnonContentLength = newLimit;
+        }
+
+        if (contentLength > maxAnonContentLength)
+        {
+            // We have to return V_AUTH_NOT_FOR_METHOD here so that
+            // the calling code can send 401. Problem is we don't have
+            // a user name or method name. Doesn't matter, though,
+            // because the calling code doesn't even look at those.
+            // So we pass in some hardcoded string. (No need to go 
+            // throught the trouble of loading the correct ones)
+
+            //caller has to send AccessDenied header
+            return VFALSE;
+        }
+    }
 
     // first, check to see if the content length of the form
     // submission exceeds the absolute maximum length that
@@ -683,7 +726,7 @@
     }
 
     if (contentLength > maxFormContentLength)
-        return;
+        return VTRUE;
 
     // Unfortunately we think that we have to read n bytes
     // in this code, not read until EOF.  Since Rogue does
@@ -703,6 +746,7 @@
     Content = cbuf;
 
     delete cbuf;
+    return VTRUE;
 }
 
 const Vchar* Vrequest::lookupArg(
@@ -960,6 +1004,10 @@
 //
 // $Log: /frontpage/server/source/wel/request.cpp $
 // 
+// 
+// 91    3/20/03 6:58p _fpdev
+// Fix for Win2k SP4.
+//
 // 90    5/13/02 8:32p _fpdev
 // (RandyTh) place a limit on extremely large posts being sent as
 // anonymous or browser level users.
--- ./wel/request.hpp.allpat	Tue Dec  3 15:34:00 2002
+++ ./wel/request.hpp	Tue Apr  8 10:28:11 2003
@@ -184,6 +184,7 @@
 protected:
     // parameters are set via CGI - read them.
     void readCGIParams();
+    Vbool readCGIParamsEx();
 
     // unlocks the service
     void unlock();
--- ./change_server.sh.allpat	Mon Feb 10 10:12:02 2003
+++ ./change_server.sh	Mon Apr  7 12:57:16 2003
@@ -1,9 +1,9 @@
 #! /bin/sh
 #
-# Copyright 1997 Microsoft Corporation -- All Rights Reserved.
+# Copyright 1997-2000 Microsoft Corporation -- All Rights Reserved.
 #
-# $Revision: 1.29 $
-# $Date: 1997/10/19 $
+# $Revision: 1.30 $
+# $Date: 2000/04/06 $
 #
 
 banner()
@@ -13,8 +13,8 @@
 
  change_server.sh
 
- Revision$Revision: 1.29 $dummy
- Date$Date: 1997/10/19 $dummy
+ Revision$Revision: 1.30 $dummy
+ Date$Date: 2000/04/06 $dummy
 
 This script will step the user through upgrading existing and installing 
 new servers and webs.  As with any software installation, a backup should be
@@ -181,7 +181,7 @@
  }
 
  httpdfile=""
- while ( [ "$httpdfile" = "" ] || [ ! -f $httpdfile ] )
+ while ( [ "$httpdfile" = "" ] || [ ! -x $httpdfile ] )
  do
      httpdfile=$DEFAULTHTTPD
      $echo "Where is the current apache daemon located:  [$httpdfile] ${nnl}"
@@ -478,8 +478,8 @@
      :multi
      s/.cnf$//'`
 
- configfile=`grep -i "^serverconfig:" $weconfigfile | sed -e '
-             s/serverconfig://g'`
+ configfile=`grep -i "^serverconfig:" $weconfigfile | sed -e 's/serverconfig://g'`
+ httpdconfigfile=$configfile
  if [ ! -f "$configfile" ]
  then
      echo "$configfile does not exist."
@@ -499,13 +499,22 @@
       *pache*)   getHttpDirective $configfile AccessConfig $port
                  if [ "$param" != "" ]
                  then
-                    file=`basename $param`
-                    accessconffile="${configfiledir}${file}"
+                    case $param in
+                        /*) accessconffile=$param  # fully qualified pathname
+                            ;;
+                        *)  file=`basename $param`
+                            accessconffile="${configfiledir}${file}"
+                            ;;
+                    esac
                  else
                     accessconffile="${configfiledir}access.conf"
+                    if [ ! -f $accessconffile ]
+                    then
+                         accessconffile=""
+                    fi
                  fi
 
-                 if [ ! -f "$accessconffile" ]
+                 if [ "$accessconffile" != "" -a "$accessconffile" != "/dev/null" -a ! -f "$accessconffile" ]
                  then
                     echo "$accessconffile does not exist."
                     return 1
@@ -1010,8 +1019,25 @@
 #
 # gets the value of parameters from the config file
 #
-    param=`egrep -i "^[ $TAB]*$1[ $TAB]" $2 | $awk '{print $2}'` || return 1
+ directive=$1
+ gpconfigfile=$2
+ port=$3
+ msg=$4
+
+ getDirective $httpdconfigfile $directive $port   # try httpd.conf first
+ if [ "$param" = "" -a -f "$gpconfigfile" ]       # try again w/configfile
+ then
+    getDirective $gpconfigfile $directive $port 
+ else
+    gpconfigfile=$httpdconfigfile
+ fi
+ echo $msg $gpconfigfile
+ if [ "$param" = "" ]
+ then
+    return 1;
+ else
     return 0;
+ fi
 }
 
 getdocroot()
@@ -1064,13 +1090,21 @@
                getHttpDirective $configfile ResourceConfig $port
                if [ "$param" != "" ]
                then
-                   file=`basename $param`
-                   resconffile="${configfiledir}${file}"
+                   case $param in
+                       /*) resconffile=$param  # fully qualified pathname
+                           ;;
+                       *)  file=`basename $param`
+                           resconffile="${configfiledir}${file}"
+                           ;;
+                   esac
                else
                    resconffile="${configfiledir}srm.conf"
+                   if [ ! -f $resconffile ]
+                   then
+                       resconffile=""
+                   fi
                fi
-               echo "Getting DocumentRoot from $resconffile."
-               getparam DocumentRoot $resconffile
+               getparam DocumentRoot $resconffile $port "Getting DocumentRoot from "
                docroot=$param
            fi
  
@@ -1084,13 +1118,21 @@
                resconffile=$param
                if [ "$param" != "" ]
                then
-                   file=`basename $param`
-                   resconffile="${configfiledir}${file}"
+                   case $param in
+                       /*) resconffile=$param  # fully qualified pathname
+                           ;;
+                       *)  file=`basename $param`
+                           resconffile="${configfiledir}${file}"
+                           ;;
+                   esac
                else
                    resconffile="${configfiledir}srm.conf"
+                   if [ ! -f $resconffile ]
+                   then
+                       resconffile=""
+                   fi
                fi
-               echo "Getting UserDir from $resconffile."
-               getparam UserDir $resconffile
+               getparam UserDir $resconffile $port "Getting UserDir from "
                userdir=$param
            fi
            ;;
@@ -1111,24 +1153,31 @@
                         *) getHttpDirective $configfile ResourceConfig $port
                            if [ "$param" != "" ]
                            then
-                               file=`basename $param`
-                               resconffile="${configfiledir}${file}"
+                               case $param in
+                                   /*) resconffile=$param  # fully qualified pathname
+                                   ;;
+                                   *)  file=`basename $param`
+                                       resconffile="${configfiledir}${file}"
+                                   ;;
+                               esac
                            else
                                resconffile="${configfiledir}srm.conf"
+                               if [ ! -f $resconffile ]
+                               then
+                                   resconffile=""
+                               fi
                            fi
 
-                           if [ ! -f "$resconffile" ]
+                           if [ "$resconffile" != "" -a "$resconffile" != "/dev/null" -a ! -f "$resconffile" ]
                            then
                                echo "ERROR: $resconffile does not exist!"
                                return 1
                            fi
 
-                           echo "Getting DocumentRoot from $resconffile."
-                           getparam DocumentRoot $resconffile
+                           getparam DocumentRoot $resconffile $port "Getting DocumentRoot from "
                            docroot=$param
  
-                           echo "Getting UserDir from $resconffile."
-                           getparam UserDir $resconffile
+                           getparam UserDir $resconffile $port "Getting UserDir from "
                            userdir=$param
                            ;; 
            esac  
@@ -1174,17 +1223,30 @@
  directive=$2
  port=$3
 
- case $port in
-    *:*) getHttpVirtualDirective $configfile $port $directive ;;
-      *) getHttpRootDirective $configfile $directive ;;
- esac
- 
+ getDirective $configfile $directive $port
  if [ "$param" = "" ]
  then
      echo "Directive $directive not found."
  else 
      echo "Found Directive $directive, value $param."
  fi
+}
+
+getDirective()
+{
+ gdconfigfile=$1
+ directive=$2
+ port=$3
+
+ if [ "$gdconfigfile" = "" ]
+ then
+    return 0
+ fi
+
+ case $port in
+    *:*) getHttpVirtualDirective $gdconfigfile $port $directive ;;
+      *) getHttpRootDirective $gdconfigfile $directive ;;
+ esac
 }
 
 getMixedCase() {
--- ./EULA.TXT.allpat	Tue Dec  3 15:34:01 2002
+++ ./EULA.TXT	Tue Dec  3 15:33:46 2002
@@ -1,58 +1,58 @@
-END-USER LICENSE AGREEMENT FOR MICROSOFT FRONTPAGE 2000 SERVER EXTENSIONS
-
-IMPORTANT-READ CAREFULLY: This Microsoft End-User License Agreement ("EULA") is a legal agreement between you (either an individual or a single entity) and Microsoft Corporation for the Microsoft software product identified above, which includes computer software and may include associated media, printed materials, and "online" or electronic documentation ("SOFTWARE PRODUCT"). By installing, copying, or otherwise using the SOFTWARE PRODUCT, you agree to be bound by the terms of this EULA. If you do not agree to the terms of this EULA, do not install or use the SOFTWARE PRODUCT; you may, however, return it to your place of purchase for a full refund.
-
-SOFTWARE PRODUCT LICENSE
-
-The SOFTWARE PRODUCT is protected by copyright laws and international copyright treaties, as well as other intellectual property laws and treaties. The SOFTWARE PRODUCT is licensed, not sold.
-
-1. GRANT OF LICENSE. This EULA grants you the following rights:
-
-* Installation and Use. You may install and use an unlimited number of copies of the SOFTWARE PRODUCT.
-
-* Reproduction and Distribution. You may reproduce and distribute an unlimited number of copies of the SOFTWARE PRODUCT; provided that each copy shall be a true and complete copy, including all copyright and trademark notices, and shall be accompanied by a copy of this EULA.  Copies of the SOFTWARE PRODUCT may be distributed as a standalone product or included with your own product.
-
-2. DESCRIPTION OF OTHER RIGHTS AND LIMITATIONS. 
-
-* Limitations on Reverse Engineering, Decompilation, and Disassembly. You may not reverse engineer, decompile, or disassemble the SOFTWARE PRODUCT, except and only to the extent that such activity is expressly permitted by applicable law notwithstanding this limitation.
-
-* Separation of Components. The SOFTWARE PRODUCT is licensed as a single product. Its component parts may not be separated for use on more than one computer.
-
-* Support Services. Microsoft may provide you with support services related to the SOFTWARE PRODUCT ("Support Services"). Use of Support Services is governed by the Microsoft policies and programs described in the user manual, in "online" documentation, and/or in other Microsoft-provided materials. Any supplemental software code provided to you as part of the Support Services shall be considered part of the SOFTWARE PRODUCT and subject to the terms and conditions of this EULA. With respect to technical information you provide to Microsoft as part of the Support Services, Microsoft may use such information for its business purposes, including for product support and development. Microsoft will not utilize such technical information in a form that personally identifies you.
-
-* Software Transfer. You may permanently transfer all of your rights under this EULA, provided the recipient agrees to the terms of this EULA.
-
-* Termination. Without prejudice to any other rights, Microsoft may terminate this EULA if you fail to comply with the terms and conditions of this EULA. In such event, you must destroy all copies of the SOFTWARE PRODUCT and all of its component parts.
-
-3. COPYRIGHT. All title and copyrights in and to the SOFTWARE PRODUCT (including but not limited to any images, photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE PRODUCT), the accompanying printed materials, and any copies of the SOFTWARE PRODUCT are owned by Microsoft or its suppliers. The SOFTWARE PRODUCT is protected by copyright laws and international treaty provisions. Therefore, you must treat the SOFTWARE PRODUCT like any other copyrighted material except that you may install the SOFTWARE PRODUCT on a single computer provided you keep the original solely for backup or archival purposes.
-
-4. U.S. GOVERNMENT RESTRICTED RIGHTS. All SOFTWARE PRODUCT provided to the U.S. Government pursuant to solicitations issued on or after December 1, 1995 is provided with the commercial rights and restrictions described elsewhere herein.  All SOFTWARE PRODUCT provided to the U.S. Government pursuant to solicitations issued prior to December 1, 1995 is provided with RESTRICTED RIGHTS as provided for in FAR, 48 CFR 52.227-14 (JUNE 1987) or FAR, 48 CFR 252.227-7013 (OCT 1988), as applicable.
-
-MISCELLANEOUS
-
-If you acquired this product in the United States, this EULA is governed by the laws of the State of Washington. 
-
-If you acquired this product in Canada, this EULA is governed by the laws of the Province of Ontario, Canada. Each of the parties hereto irrevocably attorns to the jurisdiction of the courts of the Province of Ontario and further agrees to commence any litigation which may arise hereunder in the courts located in the Judicial District of York, Province of Ontario. 
-
-If this product was acquired outside the United States, then local law may apply.
-
-Should you have any questions concerning this EULA, or if you desire to contact Microsoft for any reason, please contact the Microsoft subsidiary serving your country, or write: Microsoft Sales Information Center/One Microsoft Way/Redmond, WA 98052-6399.
-
-LIMITED WARRANTY
-
-NO WARRANTIES. Microsoft expressly disclaims any warranty for the SOFTWARE PRODUCT. The SOFTWARE PRODUCT and any related documentation is provided "as is" without warranty of any kind, either express or implied, including, without limitation, the implied warranties or merchantability, fitness for a particular purpose, or noninfringement. The entire risk arising out of use or performance of the SOFTWARE PRODUCT remains with you.
-
-NO LIABILITY FOR DAMAGES. In no event shall Microsoft or its suppliers be liable for any damages whatsoever (including, without limitation, damages for loss of business profits, business interruption, loss of business information, or any other pecuniary loss) arising out of the use of or inability to use this Microsoft product, even if Microsoft has been advised of the possibility of such damages. Because some states/jurisdictions do not allow the exclusion or limitation of liability for consequential or incidental damages, the above limitation may not apply to you.
-
-Si vous avez acquis votre produit Microsoft au CANADA, la garantie limite suivante vous concerne:
-
-GARANTIE LIMITE
-
-EXCLUSION DE GARANTIE. Microsoft exclut expressment toute garantie relative au PRODUIT LOGICIEL. Le PRODUIT LOGICIEL et la documentation y affrente sont fournis "en l'tat", sans garantie d'aucune sorte, expresse ou implicite, y compris, de manire limitative, sans aucune garantie de qualit, d'adquation  un usage particulier ou de non-contrefaon. Vous assumez l'ensemble des risques dcoulant de l'utilisation ou des performances du PRODUIT LOGICIEL.
-
-ABSENCE DE RESPONSABILIT POUR LES DOMMAGE. Microsoft ou ses fournisseurs ne pourront, en aucun cas, tre tenus pour responsables de quelque dommage que ce soit (notamment, de manire non limitative, les pertes de bnfices, les interruptions d'activit, les pertes d'informations commerciales ou d'autres pertes pcuniaires), rsultant de l'utilisation ou de l'impossibilit d'utiliser ce produit Microsoft, alors mme que Microsoft aurait t informe de la possibilit de tels dommages. Certains pays ou certaines juridictions n'autorisent pas l'exclusion ou la limitation de responsabilit pour les dommages indirects, de sorte que la limitation ci-dessus peut ne pas vous tre applicable.
-
-La prsente Convention est rgie par les lois de la province d'Ontario, Canada. Chacune des parties  la prsente reconnat irrvocablement la comptence des tribunaux de la province d'Ontario et consent  instituer tout litige qui pourrait dcouler de la prsente auprs des tribunaux situs dans le district judiciaire de York, province d'Ontario.
-
-Au cas o vous auriez des questions concernant cette licence ou que vous dsiriez vous mettre en rapport avec Microsoft pour quelque raison que ce soit, veuillez contacter la succursale Microsoft desservant votre pays, dont l'adresse est fournie dans ce produit, ou crivez  : Microsoft Sales Information Center, One Microsoft Way, Redmond, Washington 98052-6399.
-
+END-USER LICENSE AGREEMENT FOR MICROSOFT FRONTPAGE 2000 SERVER EXTENSIONS
+
+IMPORTANT-READ CAREFULLY: This Microsoft End-User License Agreement ("EULA") is a legal agreement between you (either an individual or a single entity) and Microsoft Corporation for the Microsoft software product identified above, which includes computer software and may include associated media, printed materials, and "online" or electronic documentation ("SOFTWARE PRODUCT"). By installing, copying, or otherwise using the SOFTWARE PRODUCT, you agree to be bound by the terms of this EULA. If you do not agree to the terms of this EULA, do not install or use the SOFTWARE PRODUCT; you may, however, return it to your place of purchase for a full refund.
+
+SOFTWARE PRODUCT LICENSE
+
+The SOFTWARE PRODUCT is protected by copyright laws and international copyright treaties, as well as other intellectual property laws and treaties. The SOFTWARE PRODUCT is licensed, not sold.
+
+1. GRANT OF LICENSE. This EULA grants you the following rights:
+
+* Installation and Use. You may install and use an unlimited number of copies of the SOFTWARE PRODUCT.
+
+* Reproduction and Distribution. You may reproduce and distribute an unlimited number of copies of the SOFTWARE PRODUCT; provided that each copy shall be a true and complete copy, including all copyright and trademark notices, and shall be accompanied by a copy of this EULA.  Copies of the SOFTWARE PRODUCT may be distributed as a standalone product or included with your own product.
+
+2. DESCRIPTION OF OTHER RIGHTS AND LIMITATIONS. 
+
+* Limitations on Reverse Engineering, Decompilation, and Disassembly. You may not reverse engineer, decompile, or disassemble the SOFTWARE PRODUCT, except and only to the extent that such activity is expressly permitted by applicable law notwithstanding this limitation.
+
+* Separation of Components. The SOFTWARE PRODUCT is licensed as a single product. Its component parts may not be separated for use on more than one computer.
+
+* Support Services. Microsoft may provide you with support services related to the SOFTWARE PRODUCT ("Support Services"). Use of Support Services is governed by the Microsoft policies and programs described in the user manual, in "online" documentation, and/or in other Microsoft-provided materials. Any supplemental software code provided to you as part of the Support Services shall be considered part of the SOFTWARE PRODUCT and subject to the terms and conditions of this EULA. With respect to technical information you provide to Microsoft as part of the Support Services, Microsoft may use such information for its business purposes, including for product support and development. Microsoft will not utilize such technical information in a form that personally identifies you.
+
+* Software Transfer. You may permanently transfer all of your rights under this EULA, provided the recipient agrees to the terms of this EULA.
+
+* Termination. Without prejudice to any other rights, Microsoft may terminate this EULA if you fail to comply with the terms and conditions of this EULA. In such event, you must destroy all copies of the SOFTWARE PRODUCT and all of its component parts.
+
+3. COPYRIGHT. All title and copyrights in and to the SOFTWARE PRODUCT (including but not limited to any images, photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE PRODUCT), the accompanying printed materials, and any copies of the SOFTWARE PRODUCT are owned by Microsoft or its suppliers. The SOFTWARE PRODUCT is protected by copyright laws and international treaty provisions. Therefore, you must treat the SOFTWARE PRODUCT like any other copyrighted material except that you may install the SOFTWARE PRODUCT on a single computer provided you keep the original solely for backup or archival purposes.
+
+4. U.S. GOVERNMENT RESTRICTED RIGHTS. All SOFTWARE PRODUCT provided to the U.S. Government pursuant to solicitations issued on or after December 1, 1995 is provided with the commercial rights and restrictions described elsewhere herein.  All SOFTWARE PRODUCT provided to the U.S. Government pursuant to solicitations issued prior to December 1, 1995 is provided with RESTRICTED RIGHTS as provided for in FAR, 48 CFR 52.227-14 (JUNE 1987) or FAR, 48 CFR 252.227-7013 (OCT 1988), as applicable.
+
+MISCELLANEOUS
+
+If you acquired this product in the United States, this EULA is governed by the laws of the State of Washington. 
+
+If you acquired this product in Canada, this EULA is governed by the laws of the Province of Ontario, Canada. Each of the parties hereto irrevocably attorns to the jurisdiction of the courts of the Province of Ontario and further agrees to commence any litigation which may arise hereunder in the courts located in the Judicial District of York, Province of Ontario. 
+
+If this product was acquired outside the United States, then local law may apply.
+
+Should you have any questions concerning this EULA, or if you desire to contact Microsoft for any reason, please contact the Microsoft subsidiary serving your country, or write: Microsoft Sales Information Center/One Microsoft Way/Redmond, WA 98052-6399.
+
+LIMITED WARRANTY
+
+NO WARRANTIES. Microsoft expressly disclaims any warranty for the SOFTWARE PRODUCT. The SOFTWARE PRODUCT and any related documentation is provided "as is" without warranty of any kind, either express or implied, including, without limitation, the implied warranties or merchantability, fitness for a particular purpose, or noninfringement. The entire risk arising out of use or performance of the SOFTWARE PRODUCT remains with you.
+
+NO LIABILITY FOR DAMAGES. In no event shall Microsoft or its suppliers be liable for any damages whatsoever (including, without limitation, damages for loss of business profits, business interruption, loss of business information, or any other pecuniary loss) arising out of the use of or inability to use this Microsoft product, even if Microsoft has been advised of the possibility of such damages. Because some states/jurisdictions do not allow the exclusion or limitation of liability for consequential or incidental damages, the above limitation may not apply to you.
+
+Si vous avez acquis votre produit Microsoft au CANADA, la garantie limite suivante vous concerne:
+
+GARANTIE LIMITE
+
+EXCLUSION DE GARANTIE. Microsoft exclut expressment toute garantie relative au PRODUIT LOGICIEL. Le PRODUIT LOGICIEL et la documentation y affrente sont fournis "en l'tat", sans garantie d'aucune sorte, expresse ou implicite, y compris, de manire limitative, sans aucune garantie de qualit, d'adquation  un usage particulier ou de non-contrefaon. Vous assumez l'ensemble des risques dcoulant de l'utilisation ou des performances du PRODUIT LOGICIEL.
+
+ABSENCE DE RESPONSABILIT POUR LES DOMMAGE. Microsoft ou ses fournisseurs ne pourront, en aucun cas, tre tenus pour responsables de quelque dommage que ce soit (notamment, de manire non limitative, les pertes de bnfices, les interruptions d'activit, les pertes d'informations commerciales ou d'autres pertes pcuniaires), rsultant de l'utilisation ou de l'impossibilit d'utiliser ce produit Microsoft, alors mme que Microsoft aurait t informe de la possibilit de tels dommages. Certains pays ou certaines juridictions n'autorisent pas l'exclusion ou la limitation de responsabilit pour les dommages indirects, de sorte que la limitation ci-dessus peut ne pas vous tre applicable.
+
+La prsente Convention est rgie par les lois de la province d'Ontario, Canada. Chacune des parties  la prsente reconnat irrvocablement la comptence des tribunaux de la province d'Ontario et consent  instituer tout litige qui pourrait dcouler de la prsente auprs des tribunaux situs dans le district judiciaire de York, province d'Ontario.
+
+Au cas o vous auriez des questions concernant cette licence ou que vous dsiriez vous mettre en rapport avec Microsoft pour quelque raison que ce soit, veuillez contacter la succursale Microsoft desservant votre pays, dont l'adresse est fournie dans ce produit, ou crivez  : Microsoft Sales Information Center, One Microsoft Way, Redmond, Washington 98052-6399.
+
--- ./readme.htm.allpat	Mon Feb 10 10:12:50 2003
+++ ./readme.htm	Tue Dec  3 15:33:47 2002
@@ -11,7 +11,7 @@
 <font face="Verdana">
 <h1><a name="top">Microsoft FrontPage 2000 Server Extensions SR-1, UNIX</a></h1>
 
-<font size="2"><i> Copyright Microsoft Corporation, 1995-2000&nbsp;</i></font>
+<font size="2"><i> Copyright Microsoft Corporation, 1995-2000&nbsp;</i></font
 
 
 <p>The FrontPage Server Extensions are a set of programs on the Web server that support: 
@@ -47,8 +47,8 @@
 <p>You need to take some special steps to run the FrontPage Server Extensions with Apache
 1.3.4 or greater.
 FrontPage Server Extensions expect to find all resource directives in the main server 
-configuration file, usually http.conf. To prevent the server extensions from using any secondary
-configuration files (access.conf, srm.conf), add the following lines to http.conf:</p>
+configuration file, usually httpd.conf. To prevent the server extensions from using any secondary
+configuration files (access.conf, srm.conf), add the following lines to httpd.conf:</p>
 
 
 </font>
@@ -60,9 +60,9 @@
 <font face="Verdana">
 
 
-<p>If you have some settings stored in secondary configuration files, move them to http.conf.</p>
+<p>If you have some settings stored in secondary configuration files, move them to httpd.conf.</p>
 
-<p>You must stop and restart the web server for your changes to http.conf to take effect.</p>
+<p>You must stop and restart the web server for your changes to httpd.conf to take effect.</p>
 
 
 
--- ./frontpage.cnf.allpat	Mon Feb 10 10:13:04 2003
+++ ./frontpage.cnf	Tue Dec  3 15:33:46 2002
@@ -1,6 +1,6 @@
-defaultLanguage:en
-localCharEncoding:latin1
-NoExecutableCgiUpload:1
-NoSaveResultsToAbsoluteFile:1
-NoSaveResultsPipeTo:1
-NoSaveResultsToLogDir:1
+defaultLanguage:en
+localCharEncoding:latin1
+NoExecutableCgiUpload:1
+NoSaveResultsToAbsoluteFile:1
+NoSaveResultsPipeTo:1
+NoSaveResultsToLogDir:1
--- ./releaseCode.allpat	Fri Feb 14 09:29:22 2003
+++ ./releaseCode	Wed Apr  9 14:42:32 2003
@@ -155,7 +155,7 @@
 
 LICENSE="EULA.TXT"
 
-set -x
+#set -x
 
 if [ "$PLATFORM" = "winnt" ]
 then
@@ -208,6 +208,7 @@
         rm -f $dir/*
     fi
 done
+cp $FPSRCDIR/SERK.css doc/SERK
 fi
 
 
@@ -292,24 +293,30 @@
     exit 1
 fi
 
-$LN $SRC/apache/fp-patch-apache_1.3.12 $DEST/$FRONTPAGE/apache-fp/fp-patch-apache_1.3.12
-if [ "$?" != "0" ]
+if [ ! -f $SRC/apache/fp-patch-apache_1.3.26 ] 
 then
-    exit 1
+    cp $FPSRCDIR/fp-patch-apache_1.3.26 $SRC/apache
 fi
 
-$LN $SRC/../../apache-fp/$PLATFORM/httpd.Std $DEST/$FRONTPAGE/apache-fp/httpd
+$LN $SRC/apache/fp-patch-apache_1.3.26 $DEST/$FRONTPAGE/apache-fp/fp-patch-apache_1.3.26
 if [ "$?" != "0" ]
 then
     exit 1
 fi
 
-$LN $SRC/../../apache-fp/$PLATFORM/httpd.Compat $DEST/$FRONTPAGE/apache-fp/httpd.Compat
+echo "Linking to $DEST/$FRONTPAGE/apache-fp/httpd"
+$LN $SRC/../../apache-fp/$PLATFORM/httpd.Std $DEST/$FRONTPAGE/apache-fp/httpd
 if [ "$?" != "0" ]
 then
     exit 1
 fi
 
+#$LN $SRC/../../apache-fp/$PLATFORM/httpd.Compat $DEST/$FRONTPAGE/apache-fp/httpd.Compat
+#if [ "$?" != "0" ]
+#then
+#    exit 1
+#fi
+
 fi
 
 if [ "$PLATFORM" != "winnt" ]
@@ -323,9 +330,9 @@
 
     # now that all directories and binaries are created
     # chmod them all to 755
-    chown -R bin $DEST/$FRONTPAGE
-    chgrp -R bin $DEST/$FRONTPAGE
     chmod -R 755 $DEST/$FRONTPAGE
+#    chgrp -R bin $DEST/$FRONTPAGE
+#    chown -R bin $DEST/$FRONTPAGE
 fi
 
 ## 
@@ -416,7 +423,7 @@
             exit 1
         fi
 
-    for file in $SRC/doc/SERK/4.0/*.htm
+    for file in $SRC/doc/SERK/*.htm
     do
         $LN $file $DEST/$FRONTPAGE/serk
         if [ "$?" != "0" ]
@@ -425,7 +432,7 @@
         fi
     done
 
-    for file in $SRC/doc/SERK/4.0/*.css
+    for file in $SRC/doc/SERK/*.css
     do
         $LN $file $DEST/$FRONTPAGE/serk
         if [ "$?" != "0" ]
@@ -434,9 +441,9 @@
         fi
     done
 
-    for file in $SRC/doc/SERK/4.0/*.gif
+    for file in $SRC/doc/SERK/images/*.gif
     do
-        $LN $file $DEST/$FRONTPAGE/serk
+        $LN $file $DEST/$FRONTPAGE/serk/images
         if [ "$?" != "0" ]
         then
             exit 1
@@ -518,11 +525,11 @@
         fi
     done
 
-    chown -R bin $DEST/$FRONTPAGE
-    chgrp -R bin $DEST/$FRONTPAGE
-    chmod -R a+r $DEST/$FRONTPAGE
     chmod -R u+w $DEST/$FRONTPAGE
     chmod -R go-w $DEST/$FRONTPAGE
+#    chown -R bin $DEST/$FRONTPAGE
+#    chgrp -R bin $DEST/$FRONTPAGE
+    chmod -R a+r $DEST/$FRONTPAGE
     for i in `find $DEST/$FRONTPAGE -type d` ; do
       chmod a+x $i
     done
@@ -535,10 +542,9 @@
     for i in `find $DEST/$FRONTPAGE -name \\*.sh` ; do
       chmod a+x $i
     done
-    chown root $DEST/$FRONTPAGE/apache-fp/_vti_bin/fpexe
-    chmod 4755 $DEST/$FRONTPAGE/apache-fp/_vti_bin/fpexe
     chmod 755  $DEST/$FRONTPAGE/apache-fp/httpd
-    chmod 755  $DEST/$FRONTPAGE/apache-fp/httpd.Compat
+    chmod 4755 $DEST/$FRONTPAGE/apache-fp/_vti_bin/fpexe
+#    chown root $DEST/$FRONTPAGE/apache-fp/_vti_bin/fpexe
 
     $LN $DEST/$FRONTPAGE/fp_install.sh $DEST/fp_install.sh
         if [ "$?" != "0" ]
--- ./set_default_perms.sh.allpat	Fri Mar 14 08:02:36 2003
+++ ./set_default_perms.sh	Fri Mar 14 08:03:03 2003
@@ -83,9 +83,6 @@
 # Set httpd
 chmod 555  $FPDIR/apache-fp/httpd || die make httpd executable
 
-# Set httpd.Compat
-chmod 555  $FPDIR/apache-fp/httpd.Compat || die make httpd.Compat executable
-
 # The apache-fp directory should not be writable to protect the stub program.
 chmod 555  $FPDIR/apache-fp/_vti_bin || die restrict the apache-fp directory
 
